            
            include windows.inc
            include kernel32.inc
            include user32.inc
            include gdi32.inc
            include Comctl32.inc
            include shell32.inc

            include  L:\AsmEdit\include\DSPMACRO.asm

         includelib kernel32.lib
         includelib user32.lib
         includelib gdi32.lib
         includelib Comctl32.lib
         includelib shell32.lib


ListHdrProc     PROTO  :DWORD, :DWORD, :DWORD, :DWORD
CustListProc    PROTO  :DWORD, :DWORD, :DWORD, :DWORD
EdtTextProc     PROTO  :DWORD, :DWORD, :DWORD, :DWORD
EdtLongProc     PROTO  :DWORD, :DWORD, :DWORD, :DWORD
ShowHide        PROTO  :DWORD, :DWORD

IDB_EWGRIDBUTTON  equ 100
IDC_HSIZECUR      equ 101
IDC_SPLIT         equ 102
IDC_DRAG          equ 103
IDC_DROP          equ 104
IDI_UP            equ 105
IDI_DN            equ 106

;DLGC_CODE        equ DLGC_WANTARROWS or DLGC_WANTCHARS or DLGC_WANTALLKEYS
DLGC_CODE         equ DLGC_WANTCHARS or DLGC_WANTALLKEYS

.const
AppName        db  'CustList',0
StaticClass    db  'Static',0
ListBoxClass   db  'ListBox',0
EditClass      db  'Edit',0
RichEdit       db  'RichEdit20A',0
RichEdDLL      db  'RICHED20.DLL',0

.data

.data?

hInst          dd  ?
hREdDll        dd  ?
;Cancel edit update
fCancelEdit    dd  ?

;Data used while resizing a column
fSize          dd  ?
nSizeCol       dd  ?
nSizeMin       dd  ?
nSizeOfs       dd  ?

hWnd           dd  ?
hWndStat       dd  ?
hWndListL      dd  ?
hWndListR      dd  ?
hWndListLC     dd  ?
hWndListRC     dd  ?
hWndListLP     dd  ?
hWndListRP     dd  ?
hWndTree       dd  ?
hImageList     dd  ?
RowNum         dd  ?
LeftRight      dd  ?
LeftWth        dd  ?
TreeWth        dd  ?
ShowGrid       dd  ?
CtrlOn         dd  ?
ShiftOn        dd  ?
InsertOn       dd  ?
RowSelOn       dd  ?
HitSelOn       dd  ?
RButtonOn      dd  ?
DBClickOn      dd  ?
MultSelOn      dd  ?
ReturnOn       dd  ?
DragFrTree     dd  ?
TreeOn         dd  ?
DragOn         dd  ?
DropOn         dd  ?
DropFrom       dd  ?
DropTo         dd  ?
DropClr        dd  ?
HitList        dd  ?
FrType         dd  ?
xPos           dd  ?
yPos           dd  ?
SelSortCnt     dd  ?
FileTyp        dd  ?
SelArrayL      dd  512  dup(?)
SelArrayR      dd  512  dup(?)

.data
SelArray       dd  SelArrayL,SelArrayR

.data?
SelSort        dd  512  dup(?)

hDefHeap       dd  ?
hGrp01         dd  ?
hGrp02         dd  ?
hGrp03         dd  ?
hGrp04         dd  ?

HANDLES struct
   hWnd        dd  ?              ; Main window
   hWndStat    dd  ?              ; Status bar
   hWndListL   dd  ?              ; List left
   hWndListR   dd  ?              ; List right
   hWndTree    dd  ?              ; Treeview
   hImageList  dd  ?              ; Imagelist
HANDLES ends

COLORS struct
   SelBarF     dd  ?              ; Selection Bar color
   ColumnBC    dd  ?              ; Column back ground color
   TreeBC      dd  ?              ; Tree back ground color
   ListBC      dd  ?              ; List back ground color
   Grid        dd  ?              ; Grid color
   Selection   dd  ?              ; Selection color
   SelInactive dd  ?              ; Inactive selection color
   ColumnTC    dd  ?              ; Column text color
   TreeTC      dd  ?              ; Tree text color
   ListTC      dd  ?              ; List text color
COLORS ends

;List structure
LIST struct
   Col         dd  ?              ; Current column.
   Row         dd  ?              ; Current row.
   Cols        dd  ?              ; Number of columns.
   Rows        dd  ?              ; Number of rows.
   ActRows     dd  ?              ; Actual num rows (minus fill rows).
   HeaderHgt   dd  ?              ; Header height.
   RowHgt      dd  ?              ; Row height.
   SumColWths  dd  ?              ; Sum of column widths.
   VScrollPos  dd  ?              ; Vertical scroll position.
   HScrollPos  dd  ?              ; Horizontal scroll position.
   SortFlag    dd  ?              ; Sort flags.
   hParent     dd  ?              ; Handle of parent.
   hCList      dd  ?              ; Handle of custom list.
   ID          dd  ?              ; ID of grid.
   Active      dd  ?              ; Active flag
   hHeader     dd  ?              ; Handle of header.
   hList       dd  ?              ; Handle of custom list listbox.
   hSizeBar    dd  ?              ; Handle of sizeing bar.
   hFontC      dd  ?              ; Handle of column font
   hFontL      dd  ?              ; Handle of list font
   style       dd  ?              ; List style.
   hCursor     dd  ?              ; Handle of resize cursor
   hDrag       dd  ?              ; Handle of drag cursor
   hDrop       dd  ?              ; Handle of drop cursor
   hUp         dd  ?              ; Handle of Up icon
   hDn         dd  ?              ; Handle of Down icon
   ColumnBack  dd  ?              ; Column Back color
   ColumnText  dd  ?              ; Column Text color
   ListBack    dd  ?              ; Back color
   ListGrid    dd  ?              ; Grid color
   ListText    dd  ?              ; Text color
   Selback     dd  ?              ; Select back color
   Seltext     dd  ?              ; Select text color
   SelInactive dd  ?              ; Inactive select back color
   hbrback     dd  ?              ; Back brush
   hbrSelect   dd  ?              ; Select back brush
   hbrInactive dd  ?              ; Select back inactive brush
   hbrFocus    dd  ?              ; Focus rect brush
   hListPen    dd  ?              ; List pen
   hEdit       dd  ?              ; Handle of current edit control
   hMem        dd  ?              ; Handle of data memory.
   rpMemFree   dd  ?              ; Relative pointer to next free.
   MemSize     dd  ?              ; Memory size.
   hString     dd  ?              ; Handle of string memory.
   rpStrFree   dd  ?              ; Relative pointer to next free.
   StrMemSize  dd  ?              ; String Memory size.
LIST ends

iccex          INITCOMMONCONTROLSEX <?>
dis            DRAWITEMSTRUCT       <?>

