;Ewayne (C) 2003

         .586
         .model flat, stdcall
         option casemap:none        ; Case sensitive

            include Data.inc
            include CustList.inc
            include Misc.asm
            include Sort.asm
            include ListData.asm

.code

DllEntry PROC hInstance:DWORD, reason, reserved1
LOCAL    wc:WNDCLASSEX

      .if reason == DLL_PROCESS_ATTACH
           push     hInstance
            pop     hInst
            mov     iccex.dwSize, sizeof INITCOMMONCONTROLSEX
            mov     iccex.dwICC, ICC_DATE_CLASSES or ICC_INTERNET_CLASSES or ICC_HOTKEY_CLASS
         INVOKE     InitCommonControlsEx, offset iccex

         INVOKE     LoadLibrary, addr RichEdDLL ; Load the Riched20.dll
            mov     hREdDll, eax

         INVOKE     GetProcessHeap
            mov     hDefHeap, eax

            mov     wc.cbSize, sizeof WNDCLASSEX
            mov     wc.style, CS_GLOBALCLASS or CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW
            mov     wc.lpfnWndProc, offset WndProc
            mov     wc.cbClsExtra, NULL
            mov     wc.cbWndExtra, 4            ; Holds memory handle
           push     hInst
            pop     wc.hInstance
            mov     wc.hbrBackground, NULL
            mov     wc.lpszMenuName, NULL
            mov     wc.lpszClassName, offset CListClass
            mov     eax, NULL
            mov     wc.hIcon, eax
            mov     wc.hIconSm, eax
         INVOKE     LoadCursor, NULL, IDC_ARROW ;IDC_UPARROW IDC_ARROW
            mov     wc.hCursor, eax
         INVOKE     RegisterClassEx, addr wc

      .elseif reason == DLL_PROCESS_DETACH
;---------- [Unregister our user classes] ----------
         INVOKE     UnregisterClass, offset CListClass, hInst
         INVOKE     FreeLibrary, hREdDll
      .endif
         mov     eax, TRUE
         ret
      
DllEntry ENDP

WndProc PROC uses ebx esi edi hwnd:DWORD, wMsg, wParam, lParam
LOCAL    mDC:HDC
LOCAL    rect:RECT
LOCAL    rect1:RECT
LOCAL    rect2:RECT
LOCAL    sci:SCROLLINFO
LOCAL    sfi:SHFILEINFO
LOCAL    hBtn:HWND
LOCAL    ln:LISTNOTIFY
LOCAL    stime:SYSTEMTIME
LOCAL    ftime:FILETIME
;LOCAL    dis:DRAWITEMSTRUCT
LOCAL    Val:DWORD, curcol, FirstSel, LastSel, ColumnCnt
LOCAL    szBuff01[256]:BYTE, szBuff02[64]:BYTE, szPath[256]:BYTE

         mov     eax, wMsg
      .if eax == WM_CREATE
         INVOKE     GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, 16384
         INVOKE     SetWindowLong, hwnd, 0, eax
           call     GetMem
            mov     [ebx].LIST.HeaderHgt, 17
            mov     [ebx].LIST.RowHgt, 17 ;16
            mov     [ebx].LIST.Cols, 0
            mov     [ebx].LIST.Rows, 0
            mov     [ebx].LIST.ActRows, 0
         INVOKE     GetParent, hwnd
            mov     hWnd, eax
            mov     [ebx].LIST.hParent, eax
            mov     eax, hwnd
            mov     [ebx].LIST.hCList, eax
         .if !hWndListLC
               mov     hWndListLC, eax
         .endif
         .if !hWndListRC
               mov     hWndListRC, eax
         .endif
         INVOKE     GetWindowLong, hwnd, GWL_ID
            mov     [ebx].LIST.ID, eax
         INVOKE     GetWindowLong, hwnd, GWL_STYLE
             or     eax, STYLE_NOFOCUS
            mov     [ebx].LIST.style, eax
         INVOKE     CreateSolidBrush, 000000ffh
            mov     [ebx].LIST.hbrFocus, eax
;         INVOKE     CreateSolidBrush, 00c8d0d4h
         INVOKE     CreateSolidBrush, 00ebe2d6h
            mov     [ebx].LIST.hbrInactive, eax
            mov     [ebx].LIST.Active, 1

         INVOKE     CreateWindowEx, 0, offset StaticClass, NULL,\
                    WS_CHILD or WS_CLIPSIBLINGS or SS_BLACKRECT,\
                    0, 0, 0, 0, hwnd, NULL, hInst, 0
            mov     [ebx].LIST.hSizeBar, eax

         INVOKE     CreateWindowEx, 0, offset StaticClass, NULL,\
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SS_OWNERDRAW or SS_NOTIFY,\
                    0, 0, 0, 0, hwnd, NULL, hInst, 0
            mov     [ebx].LIST.hHeader, eax

         INVOKE     SetWindowLong, [ebx].LIST.hHeader, GWL_WNDPROC, offset ListHdrProc
         INVOKE     SetWindowLong, [ebx].LIST.hHeader, GWL_USERDATA, eax

; or LBS_EXTENDEDSEL or LBS_MULTIPLESEL
         INVOKE     CreateWindowEx, 0, offset ListBoxClass, NULL,\
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or LBS_NOINTEGRALHEIGHT or\
                    LBS_OWNERDRAWFIXED or LBS_NOTIFY or LBS_MULTIPLESEL,\
                    0, 0, 0, 0, hwnd, NULL, hInst, 0
            mov     [ebx].LIST.hList, eax
         .if !hWndListL
               mov     hWndListL, eax
         .else
               mov     hWndListR, eax
         .endif
INVOKE     SetClassLong, [ebx].LIST.hList, GCL_HCURSOR, 0

         INVOKE     SetWindowLong, [ebx].LIST.hList, GWL_WNDPROC, offset CustListProc
         INVOKE     SetWindowLong, [ebx].LIST.hList, GWL_USERDATA, eax
         INVOKE     SendMessage, [ebx].LIST.hList, LB_SETITEMHEIGHT, 0, [ebx].LIST.RowHgt

         INVOKE     LoadCursor, hInst, IDC_SPLIT
            mov     [ebx].LIST.hCursor, eax
         INVOKE     LoadCursor, hInst, IDC_DRAG
            mov     [ebx].LIST.hDrag, eax
         INVOKE     LoadCursor, hInst, IDC_DROP
            mov     [ebx].LIST.hDrop, eax
         INVOKE     LoadIcon, hInst, IDI_UP      ; Up arrow
            mov     [ebx].LIST.hUp, eax
         INVOKE     LoadIcon, hInst, IDI_DN      ; Down arrow
            mov     [ebx].LIST.hDn, eax

         INVOKE     GetSysColor, COLOR_WINDOW
            mov     [ebx].LIST.ListBack, eax
         INVOKE     GetSysColor, COLOR_WINDOWTEXT
            mov     [ebx].LIST.ListText, eax
            mov     eax, COLOR_WINDOW+1
            mov     [ebx].LIST.hbrback, eax
            mov     eax, 00000000h
            mov     [ebx].LIST.ListGrid, eax
         INVOKE     CreatePen, PS_SOLID, 1, eax
            mov     [ebx].LIST.hListPen, eax
           call     RelMem

      .elseif eax == WM_SIZE
           call     GetMem
         INVOKE     GetClientRect, hwnd, addr rect
;DSPValue hWnd, rect.bottom, 1, 'm'
            mov     rect.right, 8192
            mov     eax, [ebx].LIST.HScrollPos
            sub     rect.left, eax
         INVOKE     MoveWindow, [ebx].LIST.hHeader, rect.left, 0, rect.right, [ebx].LIST.HeaderHgt, TRUE
            mov     eax, rect.bottom
            sub     eax, [ebx].LIST.HeaderHgt
         INVOKE     MoveWindow, [ebx].LIST.hList, rect.left, [ebx].LIST.HeaderHgt, rect.right, eax, TRUE
           call     SetScroll
           call     RelMem

      .elseif eax == WM_CTLCOLORLISTBOX
           call     GetMem
            mov     eax, [ebx].LIST.hbrback
           push     eax
           call     RelMem
            pop     eax
            ret

      .elseif eax == WM_DRAWITEM
           call     GetMem
;            mov     esi, lParam
;         assume esi:ptr DRAWITEMSTRUCT

               mov     esi, lParam
               lea     edi, dis
               mov     ecx, sizeof dis
               rep     movsb

            mov     eax, dis.hwndItem

         .if eax == [ebx].LIST.hHeader
;            INVOKE     GetSysColor, COLOR_BTNFACE
               mov     eax, [ebx].LIST.ColumnBack
            INVOKE     SetBkColor, dis.hdc, eax
;            INVOKE     GetSysColor, COLOR_WINDOWTEXT
               mov     eax, [ebx].LIST.ColumnText
            INVOKE     SetTextColor, dis.hdc, eax
INVOKE     SelectObject, dis.hdc, [ebx].LIST.hFontC
  push     eax
            INVOKE     ExtTextOut, dis.hdc, 0, 0, ETO_OPAQUE, addr dis.rcItem, NULL, 0, NULL
               lea     edi, [ebx+sizeof LIST]
               xor     ecx, ecx
               mov     eax, [ebx].LIST.Cols
               dec     eax
               mov     ColumnCnt, eax
            .while ecx < ColumnCnt ;[ebx].LIST.Cols
                 push     ecx
                 push     ecx
                  mov     eax, [edi].COLUMN.Colxp
               .if ecx
                     inc     eax
               .endif
                  mov     dis.rcItem.left, eax
                  add     eax, [edi].COLUMN.ColWth
               .if !ecx
                     inc     eax
               .endif
                  mov     dis.rcItem.right, eax
                 test     [edi].COLUMN.SortFlag, 1
               .if !ZERO?
                  INVOKE     DrawEdge, dis.hdc, addr dis.rcItem, BDR_SUNKENOUTER, BF_TOPLEFT
                  INVOKE     DrawEdge, dis.hdc, addr dis.rcItem, BDR_SUNKENOUTER, BF_BOTTOMRIGHT
               .else
                  INVOKE     DrawEdge, dis.hdc, addr dis.rcItem, BDR_RAISEDOUTER, BF_TOPLEFT
                  INVOKE     DrawEdge, dis.hdc, addr dis.rcItem, BDR_RAISEDOUTER, BF_BOTTOMRIGHT
               .endif
                  add     dis.rcItem.top, 2
                  add     dis.rcItem.left, 3
                  sub     dis.rcItem.right, 3
                  pop     ecx
               .if [edi].COLUMN.lpszhdrtext
mov     szBuff01, 0
                  INVOKE     SendMessage, hwnd, CM_GETHDRTEXT, ecx, addr szBuff01
                  INVOKE     lstrlen, addr szBuff01
                     mov     ecx, eax
                     lea     edx, szBuff01
                     mov     eax, [edi].COLUMN.HeaderAlign
                  .if eax == ALIGN_LEFT
                        mov     eax, DT_LEFT
                  .elseif eax == ALIGN_CENTER
                        mov     eax, DT_CENTER
                  .else
                        mov     eax, DT_RIGHT
                  .endif
                    test [edi].COLUMN.SortFlag, 1
                  .if !ZERO?
                        inc     dis.rcItem.left
                        inc     dis.rcItem.top
                        inc     dis.rcItem.right
                     INVOKE     DrawText, dis.hdc, edx, ecx, addr dis.rcItem, eax
                        dec     dis.rcItem.left
                        dec     dis.rcItem.top
                        dec     dis.rcItem.right
                  .else
                     INVOKE     DrawText, dis.hdc, edx, ecx, addr dis.rcItem, eax
                  .endif
                  .if [edi].COLUMN.SortAD
                        sub     dis.rcItem.top, 2
                        sub     dis.rcItem.right, 6
                        mov     ecx, [ebx].LIST.hUp
                     .if [edi].COLUMN.SortAD == 9
                           mov     ecx, [ebx].LIST.hDn
                     .endif
                     INVOKE     DrawIconEx, dis.hdc, dis.rcItem.right, dis.rcItem.top,\
                                ecx, 17, 17, 0, 0, DI_NORMAL
                        add     dis.rcItem.right, 6
                        add     dis.rcItem.top, 2
                  .endif
               .endif
                  sub     dis.rcItem.top, 2
                  pop     ecx
                  add     edi, sizeof COLUMN
                  inc     ecx
                  mov     eax, dis.rcItem.right
                  add     eax, 3
                  mov     dis.rcItem.left, eax
            .endw
               mov     dis.rcItem.right, 9999
            INVOKE     DrawEdge, dis.hdc, addr dis.rcItem, BDR_RAISEDOUTER, BF_TOPLEFT
            INVOKE     DrawEdge, dis.hdc, addr dis.rcItem, BDR_RAISEDOUTER, BF_BOTTOMRIGHT
   pop     eax
INVOKE     SelectObject, dis.hdc, eax

         .elseif eax == [ebx].LIST.hList
            .if dis.itemID != LB_ERR
                  and     RowSelOn, 0
                  mov     hBtn, 0
                  mov     eax, [ebx].LIST.SumColWths
                  inc     eax
                  mov     dis.rcItem.right, eax
               INVOKE     CopyRect, addr rect2, addr dis.rcItem
               INVOKE     CreateCompatibleDC, dis.hdc
                  mov     mDC, eax
               INVOKE     SelectObject, mDC, [ebx].LIST.hFontL
                 push     eax
                  mov     ecx, rect2.right
                  sub     ecx, rect2.left
                  mov     edx, rect2.bottom
                  sub     edx, rect2.top
                  xor     eax, eax
                  mov     rect2.left, eax
                  mov     rect2.top, eax
                  mov     rect2.right, ecx
                  mov     rect2.bottom, edx
               INVOKE     CreateCompatibleBitmap, dis.hdc, ecx, edx
               INVOKE     SelectObject, mDC, eax
                 push     eax
               INVOKE     SelectObject, mDC, [ebx].LIST.hListPen
                 push     eax
                  mov     eax, dis.itemID
                  inc     eax
                  sub     eax, [ebx].LIST.Rows
;DSPValue hWnd, eax, 1, 'm'
;                 test     [ebx].LIST.style, STYLE_GRIDFRAME
;               .if ZERO?
;                     dec     eax
;               .endif
;                 test   [ebx].LIST.style, STYLE_HGRIDLINES
;               .if !ZERO? || !eax
;                     dec     rect2.bottom
;                  INVOKE     MoveToEx, mDC, rect2.left, rect2.bottom, NULL
;                  INVOKE     LineTo, mDC, rect2.right, rect2.bottom
;               .elseif
;               .endif
.if ShowGrid
                     dec     rect2.bottom
                  INVOKE     MoveToEx, mDC, rect2.left, rect2.bottom, NULL
                  INVOKE     LineTo, mDC, rect2.right, rect2.bottom
.endif

               INVOKE     SetBkMode, mDC, TRANSPARENT
                  mov     eax, [ebx].LIST.style
                  and     eax, STYLE_NOSEL
                  xor     eax, STYLE_NOSEL
               .if !ZERO?
                     mov     eax, ODS_SELECTED
               .endif
                 test     dis.itemState, eax
               .if ZERO?
                     mov     eax, [ebx].LIST.ListText
                  INVOKE     SetTextColor, mDC, eax
                  INVOKE     FillRect, mDC, addr rect2, [ebx].LIST.hbrback
               .else
                  INVOKE     GetSysColor, COLOR_HIGHLIGHTTEXT
                  INVOKE     SetTextColor, mDC, eax
;                  INVOKE     FillRect, mDC, addr rect2, [ebx].LIST.hbrSelect ;COLOR_HIGHLIGHT+1
               .endif
                  lea     edi, [ebx+sizeof LIST]
                  xor     ecx, ecx
                  mov     eax, [ebx].LIST.Cols
                  dec     eax
                  mov     ColumnCnt, eax
               .while ecx < ColumnCnt ;[ebx].LIST.Cols
                     mov     curcol, ecx
                     mov     eax, [edi].COLUMN.Colxp
                     mov     rect2.left, eax
                     add     eax, [edi].COLUMN.ColWth
                     mov     rect2.right, eax

;---------- [Set select color
                     mov     ecx, curcol
                  .if ecx == [ebx].LIST.Col && (dis.itemState & ODS_SELECTED)
                     INVOKE     GetSysColor, COLOR_HIGHLIGHTTEXT
                     INVOKE     SetTextColor, mDC, eax
                        mov     RowSelOn, 1
                        mov     eax, dis.itemID
;                        mov     RowNum, eax
                        mov     ecx, curcol
                       push     rect2.left
                       push     rect2.right
                     .if ecx == 0
                           add     rect2.left, 16
                           mov     eax, dis.rcItem.right
                           sub     eax, 1
                           mov     rect2.right, eax
                     .endif
                        mov     edx, [ebx].LIST.hbrSelect
                     .if ![ebx].LIST.Active
                        INVOKE     SetTextColor, mDC, 0
                           mov     edx, [ebx].LIST.hbrInactive
                     .endif

                     INVOKE     FillRect, mDC, addr rect2, edx ;[ebx].LIST.hbrSelect
                        pop     rect2.right
                        pop     rect2.left
                  .elseif !RowSelOn
                        mov     eax, [ebx].LIST.ListText
                     INVOKE     SetTextColor, mDC, eax
;DSPValue hWnd, [ebx].LIST.Col, 1, 't'
                  .endif
                     mov     ecx, curcol
;----------

                     mov     eax, [edi].COLUMN.ColumnType
                     mov     edx, dis.itemData
                     mov     szBuff01, 0

;---------- [Draw image
                  .if ecx == 0
;DSPValue hWnd, DropTo, 1, 't'
                       push     ecx
                        mov     ecx, [ebx].LIST.Cols
                        dec     ecx
                     INVOKE     ListGetCellData, ebx, edx, ecx, addr Val
                        mov     eax, Val
                        mov     edx, eax
                        shr     edx, 16
                        mov     ecx, DropTo
.if al > 9
      sub     al, 8
.endif
                     .if edx                                                 ; Predefined Imagelist
                        INVOKE     ImageList_Draw, hImageList, edx, mDC, 1, 0, ILD_NORMAL or ILD_TRANSPARENT

                     .elseif !edx && al == 1                                 ; Go Back
                           mov     ecx, [edi].COLUMN.hImageList
                           xor     edx, edx
                           mov     dl, ah
                        INVOKE     ImageList_Draw, ecx, edx, mDC, 1, 0, ILD_NORMAL or ILD_TRANSPARENT

                     .elseif !edx && al == 2 && !DropOn ||\
                             !edx && al == 2 && DropOn && ecx != dis.itemID  ; Close folder
                           mov     ecx, [edi].COLUMN.hImageList
                           mov     edx, 1
                        INVOKE     ImageList_Draw, ecx, edx, mDC, 1, 0, ILD_NORMAL or ILD_TRANSPARENT

                     .elseif !edx && al == 2 && DropOn && ecx == dis.itemID  ; Open folder
                           mov     ecx, [edi].COLUMN.hImageList
                           mov     edx, 2

                           mov     eax, [ebx].LIST.hList
                        .if eax == hWndListR && HitList == 0 || eax == hWndListL && HitList == 1
                              mov     edx, 1
                        .endif
                        INVOKE     ImageList_Draw, ecx, edx, mDC, 1, 0, ILD_NORMAL or ILD_TRANSPARENT

                     .else                                                   ; Get Image
                        INVOKE     ListGetCellData, ebx, dis.itemData, 0, addr szBuff01
                        .if szBuff01
                           INVOKE     lstrcpy, addr szPath, [edi].COLUMN.lpszPath
                           INVOKE     lstrcat, addr szPath, addr szBuff01
                           INVOKE     SHGetFileInfo, addr szPath, 0, addr sfi, sizeof SHFILEINFO,\
                                      SHGFI_SYSICONINDEX or SHGFI_SMALLICON
                              mov     ecx, eax
                           INVOKE     ImageList_Draw, ecx, sfi.iIcon, mDC, 1, 0, ILD_NORMAL or ILD_TRANSPARENT
                        .endif
                     .endif
                           mov     eax, Val
                     .if al > 9
                          push     rect2.right
                          push     rect2.bottom
                           mov     rect2.right, 4
                           mov     rect2.bottom, 4
                        INVOKE     FillRect, mDC, addr rect2, [ebx].LIST.hbrFocus
                           pop     rect2.bottom
                           pop     rect2.right
                     .endif
                        pop     ecx
                        add     rect2.left, 16
;                        sub     rect2.right, 16
                  .endif
;----------

                     mov     eax, [edi].COLUMN.ColumnType
                     mov     edx, dis.itemData

                  .if eax == TYPE_EDITTEXT
;DSPValue hWnd, edx, 1, 't'
;DSPValue hWnd, ecx, 1, 'm'
                       push     ecx
                     INVOKE     ListGetCellData, ebx, edx, ecx, addr szBuff01
                        pop     ecx
                     .if ecx == 3 && szBuff01  ; Remove the sort year
                        INVOKE     lstrcpy, addr szBuff01, addr szBuff01+4
                     .endif
                       call     DrawItemText
.if ShowGrid
                       call     DrawItemLine
.endif
                  .elseif eax == TYPE_EDITLONG
                        mov     eax, Val
                     .if al != 1 && al != 2
                        INVOKE     ListGetCellData, ebx, edx, ecx, addr Val
                        INVOKE     BaseAscii, Val, addr szBuff01, 10, 10, 1, 0, 1
                        .if !Val
                              mov     szBuff01, 0
                        .endif
                     .else
                           mov     dword ptr szBuff01, 'RID<'
                           mov     byte ptr szBuff01+4, '>'
                           mov     byte ptr szBuff01+5, 0
                     .endif
                        mov     eax, [edi].COLUMN.lpszFormat
                     .if eax
                          call     Format
                     .endif
                       call     DrawItemText
.if ShowGrid
                       call     DrawItemLine
.endif
                  .endif
                     mov     ecx, curcol
                  .if ecx == [ebx].LIST.Col
                        mov     eax, [ebx].LIST.style
                        and     eax, STYLE_NOFOCUS
                        xor     eax, STYLE_NOFOCUS
                     .if !ZERO?
                           mov     eax, ODS_FOCUS
                          test     [ebx].LIST.style, STYLE_NOSEL
                        .if !ZERO?
                               or     eax, ODS_SELECTED
                        .endif
                     .endif
                       test     dis.itemState, eax
                     .if !ZERO?
                        INVOKE     CopyRect, addr rect, addr rect2
                        .if [ebx].LIST.Col
                              inc     rect.left
                        .endif
;                        INVOKE     DrawFocusRect, mDC, addr rect
                          test     dis.itemState, ODS_FOCUS
                        .if !ZERO?
;                              inc     rect.left
;                              inc     rect.top
;                              dec     rect.right
;                              dec     rect.bottom
;                           INVOKE     DrawFocusRect, mDC, addr rect
;                           INVOKE     FrameRect, mDC, addr rect, [ebx].LIST.hbrFocus
                        .endif
                     .endif
                  .endif
                     add       edi, sizeof COLUMN
                     mov       ecx, curcol
                     inc       ecx
               .endw
                  mov     ecx, dis.rcItem.right
                  sub     ecx, dis.rcItem.left
                  mov     edx, dis.rcItem.bottom
                  sub     edx, dis.rcItem.top
                  inc     edx
               INVOKE     BitBlt, dis.hdc, dis.rcItem.left, dis.rcItem.top, ecx, edx, mDC, 0, 0, SRCCOPY
;Restore pen
                  pop     eax
               INVOKE     SelectObject, mDC, eax
;Restore bitmap
                  pop     eax
               INVOKE     SelectObject, mDC, eax
;Delete bitmap
               INVOKE     DeleteObject, eax
;Restore font
                  pop     eax
               INVOKE     SelectObject, mDC, eax
               INVOKE     DeleteDC, mDC
               .if hBtn
                  INVOKE     InvalidateRect, hBtn, NULL, TRUE
               .endif
            .endif
         .endif
;         assume     esi:nothing
           call     RelMem
            jmp     Ret0

      .elseif eax == WM_SETFOCUS
           call     GetMem
         INVOKE     SetFocus, [ebx].LIST.hList
           call     RelMem

      .elseif eax == WM_LBUTTONDBLCLK
           call     GetMem
         INVOKE     SendMessage, [ebx].LIST.hList, WM_LBUTTONDBLCLK, 0, 0
           call     RelMem

      .elseif eax == WM_MOUSEWHEEL
            mov     eax, wParam
         .if sdword ptr eax < 0
            INVOKE     SendMessage, hwnd, WM_VSCROLL, SB_LINEDOWN, 0
            INVOKE     SendMessage, hwnd, WM_VSCROLL, SB_LINEDOWN, 0
            INVOKE     SendMessage, hwnd, WM_VSCROLL, SB_LINEDOWN, 0
         .else
            INVOKE     SendMessage, hwnd, WM_VSCROLL, SB_LINEUP, 0
            INVOKE     SendMessage, hwnd, WM_VSCROLL, SB_LINEUP, 0
            INVOKE     SendMessage, hwnd, WM_VSCROLL, SB_LINEUP, 0
         .endif
            jmp        Ret0

      .elseif eax == WM_VSCROLL
           call     GetMem
            mov     sci.cbSize, sizeof sci
            mov     sci.fMask, SIF_ALL
         INVOKE     GetScrollInfo, hwnd, SB_VERT, addr sci
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETTOPINDEX, 0, 0
            mov     edx, wParam
          movzx     edx, dx
         .if edx == SB_THUMBTRACK || edx == SB_THUMBPOSITION
               mov     eax, sci.nTrackPos
         .elseif edx == SB_LINEDOWN
               inc     eax
               mov     edx, sci.nMax
               sub     edx, sci.nPage
               inc     edx
            .if eax > edx
                  mov     eax, edx
            .endif
         .elseif edx == SB_LINEUP
            .if eax
                  dec     eax
            .endif
         .elseif edx == SB_PAGEDOWN
               add     eax, sci.nPage
               mov     edx, sci.nMax
               sub     edx, sci.nPage
               inc     edx
            .if eax > edx
                  mov     eax, edx
            .endif
         .elseif edx == SB_PAGEUP
               sub     eax, sci.nPage
               jnb     NotMinus
               xor     eax, eax
NotMinus:
         .elseif edx == SB_BOTTOM
               mov     eax, sci.nMax
         .elseif edx == SB_TOP
               xor       eax, eax
         .endif
         .if eax != sci.nPos
               mov     sci.nPos, eax
               mov     [ebx].LIST.VScrollPos, eax
            INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE
            INVOKE     SendMessage, [ebx].LIST.hList, LB_SETTOPINDEX, sci.nPos, 0
              call     SetScroll
         .endif
           call     RelMem

      .elseif eax == WM_HSCROLL
           call     GetMem
            mov     sci.cbSize, sizeof sci
            mov     sci.fMask, SIF_ALL
         INVOKE     GetScrollInfo, hwnd, SB_HORZ, addr sci
            mov     eax, [ebx].LIST.HScrollPos
            mov     edx, wParam
          movzx     edx, dx
         .if edx == SB_THUMBTRACK || edx == SB_THUMBPOSITION
               mov       eax, sci.nTrackPos
         .elseif edx == SB_LINEDOWN
               add       eax, 5
               mov       edx, sci.nMax
               sub       edx, sci.nPage
               inc       edx
            .if eax > edx
                  mov     eax, edx
            .endif
         .elseif edx == SB_LINEUP
               sub       eax, 5
               jnb       @f
               xor       eax, eax
@@:
         .elseif edx == SB_PAGEDOWN
               add       eax, sci.nPage
               mov       edx, sci.nMax
               sub       edx, sci.nPage
               inc       edx
            .if eax > edx
                  mov     eax, edx
            .endif
         .elseif edx == SB_PAGEUP
               sub       eax, sci.nPage
               jnb       @f
               xor       eax, eax
@@:
         .elseif edx == SB_BOTTOM
               mov       eax, sci.nMax
         .elseif edx == SB_TOP
               xor       eax, eax
         .endif
            mov     sci.nPos, eax
            mov     edx, [ebx].LIST.HScrollPos
            sub     edx, eax
            mov     [ebx].LIST.HScrollPos, eax
         INVOKE     ScrollWindow, hwnd, edx, 0, NULL, NULL
           call     SetScroll
           call     RelMem

      .elseif eax == WM_DESTROY
           call     GetMem
         INVOKE     DestroyWindow, [ebx].LIST.hSizeBar
         INVOKE     DestroyWindow, [ebx].LIST.hHeader
         INVOKE     DestroyWindow, [ebx].LIST.hList
         INVOKE     DestroyCursor, [ebx].LIST.hCursor
         INVOKE     DestroyCursor, [ebx].LIST.hDrag
         INVOKE     DestroyCursor, [ebx].LIST.hDrop
         INVOKE     DestroyIcon, [ebx].LIST.hUp
         INVOKE     DestroyIcon, [ebx].LIST.hDn

;         .if ![ebx].LIST.hbrback == COLOR_WINDOW+1
         .if [ebx].LIST.hbrback
            INVOKE     DeleteObject, [ebx].LIST.hbrback
         .endif
         INVOKE     DeleteObject, [ebx].LIST.hbrSelect
         INVOKE     DeleteObject, [ebx].LIST.hbrInactive
         INVOKE     DeleteObject, [ebx].LIST.hbrFocus
         INVOKE     DeleteObject, [ebx].LIST.hListPen
            mov     eax, [ebx].LIST.hMem
         .if eax
            INVOKE     GlobalFree, eax
         .endif
            mov     eax, [ebx].LIST.hString
         .if eax
            INVOKE     GlobalFree, eax
         .endif
           call     RelMem
         INVOKE     GetWindowLong, hwnd, 0
         INVOKE     GlobalFree, eax
         INVOKE     SetWindowLong, hwnd, 0, 0

      .elseif eax == CM_LEFTWIDTH
            mov     eax, wParam
;            add     eax, 4
            mov     LeftWth, eax
            jmp     Ret0

      .elseif eax == CM_GETSCROLLPOS
           call     GetMem
            mov     eax, [ebx].LIST.VScrollPos
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_SETSCROLLPOS
           call     GetMem
.if [ebx].LIST.VScrollPos
         INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE
            mov     ecx, [ebx].LIST.VScrollPos
         INVOKE     SendMessage, [ebx].LIST.hList, LB_SETTOPINDEX, ecx, 0
           call     SetScroll
.endif
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_GETSUMCOLWIDTH
           call     GetMem
            mov     eax, [ebx].LIST.SumColWths
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_ADDCOL
           call     GetMem
;mov     esi, lParam
;mov     eax, [esi].COLUMN.ColNum
;DSPValue hWnd, eax, 1, 'm'
;DSPValue hWnd, [ebx].LIST.Cols, 1, 'm'
         .if ![ebx].LIST.hMem ;|| eax > [ebx].LIST.Cols
               mov     eax, sizeof COLUMN
               mov     edx, [ebx].LIST.Cols
               mul     edx
               lea     edi, [ebx+eax+sizeof LIST]
               mov     esi, lParam
               mov     eax, [esi].COLUMN.lpszPath
               mov     [edi].COLUMN.lpszPath, eax
               mov     eax, [esi].COLUMN.ColWth
               mov     [edi].COLUMN.ColWth, eax
               mov     eax, [esi].COLUMN.lpszhdrtext
               mov     [edi].COLUMN.lpszhdrtext, eax
               mov     [edi].COLUMN.lpszFormat, 0
               mov     eax, [esi].COLUMN.HeaderAlign
               mov     [edi].COLUMN.HeaderAlign, eax
               mov     eax, [esi].COLUMN.ColumnAlign
               mov     [edi].COLUMN.ColumnAlign, eax
               mov     eax, [esi].COLUMN.MaxLen
               mov     [edi].COLUMN.MaxLen, eax
               mov     eax, [esi].COLUMN.SortFlag
               mov     [edi].COLUMN.SortFlag, eax
               mov     eax, [esi].COLUMN.lpszFormat
               mov     [edi].COLUMN.lpszFormat, eax
               mov     eax, [esi].COLUMN.hImageList
               mov     [edi].COLUMN.hImageList, eax
               mov     eax, [esi].COLUMN.ColumnType
               mov     [edi].COLUMN.ColumnType, eax
               mov     eax, [esi].COLUMN.ColNum
               mov     [edi].COLUMN.ColNum, eax
               mov     eax, [esi].COLUMN.SortAD
               mov     [edi].COLUMN.SortAD, eax

            .if eax == TYPE_EDITTEXT ; or WS_BORDER
               INVOKE     CreateWindowEx, 0, offset EditClass, NULL,\
                          WS_CHILD or WS_CLIPSIBLINGS or ES_AUTOHSCROLL,\
                          0, 0, 0, 0, [ebx].LIST.hList, NULL, hInst, 0
                  mov     [edi].COLUMN.EditWnd, eax

               INVOKE     SetWindowLong, eax, GWL_WNDPROC, offset EdtTextProc
               INVOKE     SetWindowLong, [edi].COLUMN.EditWnd, GWL_USERDATA, eax
                  mov     eax, [edi].COLUMN.MaxLen
               .if !eax || eax > 511
                     mov       eax, 511
                     mov       [edi].COLUMN.MaxLen, eax
               .endif
               INVOKE     SendMessage, [edi].COLUMN.EditWnd, EM_LIMITTEXT, eax, 0
            mov     ecx, [ebx].LIST.hFontL
         INVOKE     SendMessage, [edi].COLUMN.EditWnd, WM_SETFONT, ecx, TRUE

            .elseif eax == TYPE_EDITLONG
               INVOKE     CreateWindowEx, 0, offset EditClass, NULL,\
                          WS_CHILD or WS_BORDER or WS_CLIPSIBLINGS or ES_AUTOHSCROLL or ES_RIGHT,\
                          0, 0, 0, 0, [ebx].LIST.hList, NULL, hInst, 0
                  mov     [edi].COLUMN.EditWnd, eax

               INVOKE     SetWindowLong, eax, GWL_WNDPROC, offset EdtLongProc
               INVOKE     SetWindowLong, [edi].COLUMN.EditWnd, GWL_USERDATA, eax
                  mov     eax, [edi].COLUMN.MaxLen
               .if !eax || eax > 11
                     mov     eax, 11
                     mov     [edi].COLUMN.MaxLen, eax
               .endif
               INVOKE     SendMessage, [edi].COLUMN.EditWnd, EM_LIMITTEXT, eax, 0
            .endif

               mov     eax, [edi].COLUMN.EditWnd
            .if eax
                 push     eax
               INVOKE     SendMessage, [ebx].LIST.hList, WM_GETFONT, 0, 0
                  pop     edx
               INVOKE     SendMessage, edx, WM_SETFONT, eax, FALSE
            .endif
               mov     eax, [ebx].LIST.SumColWths
;DSPValue hWnd, 1111, 1, 'm'
;DSPValue hWnd, eax, 1, 'm'
               mov     [edi].COLUMN.Colxp, eax
               add     eax, [edi].COLUMN.ColWth
               mov     [ebx].LIST.SumColWths, eax
               mov     edx, [ebx].LIST.Cols
               inc     [ebx].LIST.Cols
               mov     eax, [edi].COLUMN.lpszhdrtext
            .if eax
                 push     edx
               INVOKE     SendMessage, hwnd, CM_SETHDRTEXT, edx, eax
                  pop     edx
            .endif
         .else
;** Error,  data in grid
               xor     eax, eax
               inc     eax
         .endif
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_SETHANDLES
         INVOKE     SetHandles, lParam
            jmp     Ret0

      .elseif eax == CM_SETCOLORS
           call     GetMem
         INVOKE     SetColors, ebx, lParam
         .if [ebx].LIST.hbrback
            INVOKE     DeleteObject, [ebx].LIST.hbrback
         .endif
            mov     eax, [ebx].LIST.ListBack
         INVOKE     CreateSolidBrush, eax
            mov     [ebx].LIST.hbrback, eax
         .if [ebx].LIST.hListPen
            INVOKE     DeleteObject, [ebx].LIST.hListPen
         .endif
            mov     eax, [ebx].LIST.ListGrid
         INVOKE     CreatePen, PS_SOLID, 1, eax
            mov     [ebx].LIST.hListPen, eax
         .if [ebx].LIST.hbrSelect
            INVOKE     DeleteObject, [ebx].LIST.hbrSelect
         .endif
            mov     eax, [ebx].LIST.Selback
         INVOKE     CreateSolidBrush, eax
            mov     [ebx].LIST.hbrSelect, eax
         .if [ebx].LIST.hbrInactive
            INVOKE     DeleteObject, [ebx].LIST.hbrInactive
         .endif
            mov     eax, [ebx].LIST.SelInactive
         INVOKE     CreateSolidBrush, eax
            mov     [ebx].LIST.hbrInactive, eax
         INVOKE     InvalidateRect, [ebx].LIST.hHeader, NULL, TRUE
         INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_SETFONTS
           call     GetMem
            mov     esi, wParam
            mov     [ebx].LIST.hFontC, esi
            mov     edi, lParam
            mov     [ebx].LIST.hFontL, edi
         INVOKE     SendMessage, [ebx].LIST.hHeader, WM_SETFONT, esi, FALSE
         INVOKE     SendMessage, [ebx].LIST.hList, WM_SETFONT, edi, FALSE
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_ADDROW
           call     GetMem

            mov     esi, lParam
            mov     eax, [esi]
         .if eax
               inc     [ebx].LIST.ActRows
         .endif

         INVOKE     ListAddRowData, ebx, lParam
            inc     [ebx].LIST.Rows
         INVOKE     SendMessage, [ebx].LIST.hList, LB_ADDSTRING, 0, eax
           push     eax
         INVOKE     SendMessage, hwnd, CM_SCROLLLIST, 0, 0
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_SENDDRAG
           call     GetMem
           call     SetNotify
            mov     ln.nmhdr.code, CN_DRAG
            mov     ln.lpdata, 0
            mov     eax, DragOn
            mov     ln.DragOn, eax
         INVOKE     SendMessage, [ebx].LIST.hParent, WM_NOTIFY, ln.nmhdr.idFrom, addr ln
           call     RelMem
            xor     eax, eax
            jmp     RetV

      .elseif eax == CM_SENDDROP
            mov     DropOn, 1
           call     GetMem
           call     SetNotify
            mov     ln.nmhdr.code, CN_DRAGDROP
            mov     ln.lpdata, 0
            mov     eax, HitList
            mov     ln.HitList, eax
            mov     eax, DropTo
            mov     ln.HitRow, eax
;DSPValue hWnd, ln.nmhdr.code, 1, 't'
         INVOKE     SendMessage, [ebx].LIST.hParent, WM_NOTIFY, ln.nmhdr.idFrom, addr ln
            and     DropOn, 0
           call     RelMem
            xor     eax, eax
            jmp     RetV

      .elseif eax == CM_DBCLICK
           call     GetMem
            mov     edx, lParam
            mov     eax, wParam
         .if eax < [ebx].LIST.Cols && edx < [ebx].LIST.Rows
               mov     ecx, edx
               shl     ecx, 16
               add     ecx, eax
              push     ecx 
              call     SetNotify
               mov     ln.nmhdr.code, CN_BEFORESELCHANGE
               pop     ecx
               shr     ecx, 16
               mov     ln.Row, ecx
               mov     ln.lpdata, 0
               mov     eax, DBClickOn
               mov     ln.DBClick, eax
               mov     eax, FileTyp
               mov     ln.FileTyp, eax
            INVOKE     SendMessage, [ebx].LIST.hParent, WM_NOTIFY, ln.nmhdr.idFrom, addr ln
               mov     ln.DBClick, 0
               mov     ln.FileTyp, 0
         .endif
           call     RelMem
            xor     eax, eax
            jmp     RetV

      .elseif eax == CM_CHECKSELECT
           call     GetMem
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSELITEMS, 512, lParam
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_SETSELECTALL
           call     GetMem
            mov     ecx, [ebx].LIST.Cols
            dec     ecx
         INVOKE     ListGetCellData, ebx, 0, ecx, addr Val
            mov     edx, [ebx].LIST.ActRows
            xor     ecx, ecx
         .if Val == 1
               mov     ecx, 1
               dec     edx
         .endif
         INVOKE     SendMessage, [ebx].LIST.hList, LB_SELITEMRANGEEX, ecx, edx
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_CLEARSELECT
           call     GetMem
         INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, FALSE, -1
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_INVERTSELECT
           call     GetMem
            mov     esi, LeftRight
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSELITEMS, 512, SelArray[esi]
            mov     SelSortCnt, eax
            mov     ecx, [ebx].LIST.Cols
            dec     ecx
         INVOKE     ListGetCellData, ebx, 0, ecx, addr Val
            mov     edx, [ebx].LIST.ActRows
            xor     ecx, ecx
         .if Val == 1
               mov     ecx, 1
               dec     edx
         .endif
         INVOKE     SendMessage, [ebx].LIST.hList, LB_SELITEMRANGEEX, ecx, edx
            mov     esi, LeftRight
            mov     esi, SelArray[esi]
            xor     edi, edi
         .while (SelSortCnt)
               mov     ecx, [esi+edi*4]
            INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, FALSE, ecx
               inc     edi
               dec     SelSortCnt
         .endw
            mov     esi, LeftRight
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSELITEMS, 512, SelArray[esi]
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_SETCURSEL
         .if InsertOn
               inc     lParam
               and     InsertOn, 0
         .endif
           call     GetMem
            mov     edx, lParam
            mov     eax, wParam
         .if eax < [ebx].LIST.Cols && edx < [ebx].LIST.Rows
               mov     ecx, edx
               shl     ecx, 16
               add     ecx, eax
              push     ecx 
              call     SetNotify
               mov     ln.nmhdr.code, CN_BEFORESELCHANGE
               pop     ecx
               shr     ecx, 16
               mov     ln.Row, ecx
               mov     ln.lpdata, 0
               mov     eax, RButtonOn
               mov     ln.RButt, eax
               mov     eax, FileTyp
               mov     ln.FileTyp, eax
            INVOKE     SendMessage, [ebx].LIST.hParent, WM_NOTIFY, ln.nmhdr.idFrom, addr ln
               mov     ln.RButt, 0
            .if !ln.fcancel
               INVOKE     GetFocus
                  mov     LeftRight, 0
               .if eax == hWndListR
                     mov     LeftRight, 4
               .endif
;DSPValue hWnd, LeftRight, 1, 't'

                  mov     eax, ln.Col
                  mov     [ebx].LIST.Col, eax
                  mov     eax, ln.Row
                  mov     [ebx].LIST.Row, eax
;.if RButtonOn
;     call     RelMem
;      xor     eax, eax
;      jmp     RetV
;.endif
                  mov     FirstSel, eax
                  mov     LastSel, eax
;               INVOKE     SendMessage, [ebx].LIST.hList, LB_SETCURSEL, eax, 0

                  mov     edi, eax
                  mov     esi, LeftRight
               .if ShiftOn
                  INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSELITEMS, 512, SelArray[esi]
                  INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSELCOUNT, 0, 0
                     mov     ecx, eax
                     xor     edx, edx
                     mov     esi, LeftRight
                     mov     esi, SelArray[esi]
                     mov     eax, [esi+edx*4]
                     mov     FirstSel, eax
                  .while (ecx)
                        mov     eax, [esi+edx*4]
                        mov     LastSel, eax
                        inc     edx
                        dec     ecx
                  .endw

                  INVOKE     SendMessage, [ebx].LIST.hList, LB_SELITEMRANGEEX, FirstSel, LastSel

               .else
                  INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, TRUE, edi ;;;;
               .endif
                  mov     ecx, LeftRight
               INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSELITEMS, 512, SelArray[ecx]

;LB_SELITEMRANGEEX
;LB_GETSELCOUNT
;LB_GETSELITEMS
;SelArrayL
               INVOKE     SendMessage, hwnd, CM_SCROLLLIST, 0, 0
                 call     SetNotify
                  mov     ln.nmhdr.code, CN_AFTERSELCHANGE
                  mov     ln.lpdata, 0
;                  mov     eax, RButtonOn
;                  mov     ln.RButt, eax
               INVOKE     SendMessage, [ebx].LIST.hParent, WM_NOTIFY, ln.nmhdr.idFrom, addr ln
                  xor     eax, eax
                  inc     eax
            .else
                  xor     eax, eax
            .endif
         .else
               xor       eax, eax
         .endif
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_GETCURCOL
           call     GetMem
            mov     eax, [ebx].LIST.Col
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_GETCURROW
           call     GetMem
            mov     eax, [ebx].LIST.Row
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == LB_GETCOUNT
           call     GetMem
            mov     eax, [ebx].LIST.Rows
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_GETCELLDATA
           call     GetMem
            mov     eax, wParam
            shr     eax, 16
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETITEMDATA, eax, 0
            mov     ecx, wParam
          movzx     ecx, cx
         INVOKE     ListGetCellData, ebx, eax, ecx, lParam
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_SETCELLDATA
           call     GetMem
            mov     ecx, wParam
           call     SetNotify
            mov     ln.nmhdr.code, CN_BEFOREUPDATE
            mov     eax, lParam
            mov     ln.lpdata, eax
         INVOKE     SendMessage, [ebx].LIST.hParent, WM_NOTIFY, ln.nmhdr.idFrom, addr ln
         .if !ln.fcancel
               mov     eax, wParam
               shr     eax, 16
            INVOKE     SendMessage, [ebx].LIST.hList, LB_GETITEMDATA, eax, 0
               mov     ecx, wParam
             movzx     ecx, cx
            INVOKE     ListSetCellData, ebx, eax, ecx, lParam
               mov     ecx, wParam
               shr     ecx, 16
            INVOKE     SendMessage, [ebx].LIST.hList, LB_GETITEMRECT, ecx, addr rect
            INVOKE     InvalidateRect, [ebx].LIST.hList, addr rect, TRUE
               mov     ln.nmhdr.code, CN_AFTERUPDATE
               mov     eax, wParam
            .if !ax    ; File name only
               INVOKE     SendMessage, [ebx].LIST.hParent, WM_NOTIFY, ln.nmhdr.idFrom, addr ln
            .endif
         .endif
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_GETCELLRECT
           call     GetMem
            xor     eax, eax
            mov     rect.left, eax
            mov     rect.top, eax
            mov     rect.right, eax
            mov     rect.bottom, eax
            mov     ecx, wParam
          movzx     ecx, cx
         .if ecx < [ebx].LIST.Cols
               mov     eax, sizeof COLUMN
               mul     ecx
               lea     edi, [ebx+eax+sizeof LIST]
               mov     ecx, wParam
               shr     ecx, 16
            .if ecx < [ebx].LIST.Rows
               INVOKE     SendMessage, [ebx].LIST.hList, LB_GETITEMRECT, ecx, addr rect
                  mov     eax, [edi].COLUMN.Colxp
                  sub     eax, [ebx].LIST.HScrollPos
                  mov     rect.left, eax
                  add     eax, [edi].COLUMN.ColWth
                  mov     rect.right, eax
            .endif
         .endif
         INVOKE     CopyRect, lParam, addr rect
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_SCROLLLIST
         INVOKE     GetClientRect, hwnd, addr rect1
         .if rect1.right && rect1.bottom
              call     GetMem
            INVOKE     SendMessage, [ebx].LIST.hList, LB_GETCURSEL, 0, 0
               mov     [ebx].LIST.Row, eax
               mov     eax, [ebx].LIST.RowHgt
               sub     rect1.bottom, eax
               mov     ecx, [ebx].LIST.Row
               shl     ecx, 16
               add     ecx, [ebx].LIST.Col
            INVOKE     SendMessage, hwnd, CM_GETCELLRECT, ecx, addr rect
            .if sdword ptr rect.top < 0
               INVOKE     SendMessage, [ebx].LIST.hList, LB_SETTOPINDEX, [ebx].LIST.Row, 0
            .else
                  mov     eax, rect.bottom
               .if eax > rect1.bottom
                     sub     eax, rect1.bottom
;---------- [Sign extends the 32 bit value in eax to 64 bits and places the result in edx:eax
                     cdq
                     mov     ecx, [ebx].LIST.RowHgt
                     div     ecx
                     inc     eax
                    push     eax
                  INVOKE     SendMessage, [ebx].LIST.hList, LB_GETTOPINDEX, 0, 0
                     pop     edx
                     add     eax, edx
                  INVOKE     SendMessage, [ebx].LIST.hList, LB_SETTOPINDEX, eax, 0
               .endif
            .endif
            .if sdword ptr rect.left < 0
                  mov     eax, rect.left
                  add     [ebx].LIST.HScrollPos, eax
                  neg     eax
               INVOKE     ScrollWindow, hwnd, eax, 0, NULL, NULL
            .else
                  mov     eax, rect.right
               .if eax > rect1.right
                     sub     eax, rect1.right
                     mov     edx, [ebx].LIST.HScrollPos
                     add     edx, eax
                     cmp     rect.left, eax
                  .if CARRY?
                        mov     eax, rect.left
                        mov     edx, eax
                        add     edx, [ebx].LIST.HScrollPos
                  .endif
                     mov     [ebx].LIST.HScrollPos, edx
                     neg     eax
                  INVOKE     ScrollWindow, hwnd, eax, 0, NULL, NULL
               .endif
            .endif
              call     SetScroll
              call     RelMem
         .else
              call     GetMem
            INVOKE     SendMessage, [ebx].LIST.hList, LB_SETTOPINDEX, 0, 0
              call     RelMem
         .endif
            jmp     Ret0

      .elseif eax == CM_SETGRIDLINES
           call     GetMem
            mov     eax, wParam
            mov     ShowGrid, eax
         INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_SETACTIVE
           call     GetMem
            mov     eax, lParam
            mov     [ebx].LIST.Active, eax
         INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE
         INVOKE     UpdateWindow, [ebx].LIST.hList
         .if wParam
              call     SetNotify
mov     ln.nmhdr.code, CN_SETACTIVE
            INVOKE     SendMessage, [ebx].LIST.hParent, WM_NOTIFY, ln.nmhdr.idFrom, addr ln
         .endif
      INVOKE     GetFocus
         mov     LeftRight, 0
      .if eax == hWndListR
            mov     LeftRight, 4
      .endif
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_SETTREE
            mov     eax, wParam
            add     eax, 3
            mov     TreeWth, eax
            mov     eax, lParam
            mov     TreeOn, eax
            jmp     Ret0

      .elseif eax == CM_SETTREEMODE
            mov     eax, lParam
            mov     DragFrTree, eax
            mov     FrType, 2
            jmp     Ret0

      .elseif eax == CM_REDRAW
           call     GetMem
         INVOKE     InvalidateRect, [ebx].LIST.hHeader, NULL, TRUE
         INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_ENTEREDIT
           call     GetMem
            mov     eax, [ebx].LIST.Rows
         .if eax
            .if wParam != 44
               INVOKE     SendMessage, hwnd, CM_SETCURSEL, wParam, lParam
            .endif
               mov     ecx, [ebx].LIST.Row
               shl     ecx, 16
               add     ecx, [ebx].LIST.Col
              push     ecx
            INVOKE     SendMessage, hwnd, CM_GETCELLDATA, ecx, addr szBuff01
               pop     ecx
              push     ecx
            INVOKE     SendMessage, hwnd, CM_GETCELLRECT, ecx, addr rect
               pop     ecx
              push     ecx
              call     SetNotify
               mov     ln.nmhdr.code, CN_BEFOREEDIT
               lea     eax, szBuff01
               mov     ln.lpdata, eax
               mov     eax, [ebx].LIST.Col
               mov     edx, sizeof COLUMN
               mul     edx
               lea     edi, [ebx+eax+sizeof LIST]
               mov     eax, [edi].COLUMN.EditWnd
               mov     ln.hwnd, eax
            INVOKE     SendMessage, [ebx].LIST.hParent, WM_NOTIFY, ln.nmhdr.idFrom, addr ln
               pop     ecx
               xor     eax, eax
            .if !ln.fcancel
               .if [edi].COLUMN.EditWnd
                  INVOKE     SetWindowLong, [edi].COLUMN.EditWnd, GWL_ID, ecx
                  INVOKE     GetClientRect, [ebx].LIST.hList, addr rect1
                     mov     ecx, [edi].COLUMN.ColWth
                     mov     edx, [ebx].LIST.RowHgt
                     mov     eax, [edi].COLUMN.ColumnType

                  .if eax == TYPE_EDITTEXT
                       push     esi
                        mov     esi, [edi].COLUMN.Colxp
                        add     esi, 16 ;18
                        sub     ecx, 16 ;18
                        dec     edx
.if !ShowGrid
      inc     rect.top
      dec     edx
.endif
                     INVOKE     MoveWindow, [edi].COLUMN.EditWnd, esi, rect.top, ecx, edx, TRUE
                        pop     esi
                     INVOKE     SendMessage, [edi].COLUMN.EditWnd, WM_SETTEXT, 0, addr szBuff01
                     INVOKE     SendMessage, [edi].COLUMN.EditWnd, EM_SETSEL, 0, -1

                  .elseif eax == TYPE_EDITLONG
                     INVOKE     MoveWindow, [edi].COLUMN.EditWnd, [edi].COLUMN.Colxp, rect.top, ecx, edx, TRUE
                        mov     edx, dword ptr szBuff01
                     INVOKE     BaseAscii, edx, addr szBuff01, 10, 10, 1, 0, 1
                     INVOKE     SendMessage, [edi].COLUMN.EditWnd, WM_SETTEXT, 0, addr szBuff01
                     INVOKE     SendMessage, [edi].COLUMN.EditWnd, EM_SETSEL, 0, -1
                  .endif

                  INVOKE     ShowWindow, [edi].COLUMN.EditWnd, SW_SHOW
                  INVOKE     SetFocus, [edi].COLUMN.EditWnd
@@:
                     mov     eax, [edi].COLUMN.EditWnd
               .else
                     mov     eax, [edi].COLUMN.ColumnType
                     xor     eax, eax
               .endif
            .endif
         .endif
            mov     [ebx].LIST.hEdit, eax
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV


      .elseif eax == CM_ENDEDIT
           call     GetMem
         .if !lParam
               mov     dword ptr szBuff01, 0
               mov     eax, wParam
             movzx     eax, ax
               mov     ecx, sizeof COLUMN
               mul     ecx
               lea     edi, [ebx+eax+sizeof LIST]
               mov     eax, [edi].COLUMN.ColumnType
            .if [ebx].LIST.hEdit
               .if eax == TYPE_EDITTEXT
                  INVOKE     SendMessage, [ebx].LIST.hEdit, WM_GETTEXT, sizeof szBuff01, addr szBuff01
               .elseif eax == TYPE_EDITLONG
                  INVOKE     SendMessage, [ebx].LIST.hEdit, WM_GETTEXT, sizeof szBuff02, addr szBuff02
;                  INVOKE     DecToBin, addr szBuff01
                    push     esi
                    push     edi
                     xor     esi, esi
                     xor     edi, edi
                  INVOKE     lstrlen, addr szBuff02
                     mov     ecx, eax
                  .while (ecx)
                        mov     al, byte ptr szBuff02[esi]
                     .if al >= '0' && al <= '9' || al == '-'
                           mov     byte ptr szBuff01[edi], al
                           mov     byte ptr szBuff01[edi+1], 0
                           inc     edi
                     .endif
                        inc     esi
                        dec     ecx
                  .endw
                     pop     edi
                     pop     esi
                  INVOKE     AsciiBase, addr szBuff01, addr Val, 10
                     mov     eax, Val
                     mov     dword ptr szBuff01, eax
               .endif
            .endif
               mov     ecx, wParam
              call     SetNotify
               mov     ln.nmhdr.code, CN_AFTEREDIT
               lea     eax, szBuff01
               mov     ln.lpdata, eax
               mov     eax, [edi].COLUMN.EditWnd
               mov     ln.hwnd, eax
            INVOKE     SendMessage, [ebx].LIST.hParent, WM_NOTIFY, ln.nmhdr.idFrom, addr ln
            .if !ln.fcancel
               .if ReturnOn
                  INVOKE     SendMessage, hwnd, CM_SETCELLDATA, wParam, addr szBuff01
               .endif
                  mov     eax, [ebx].LIST.hEdit
               .if eax
                  INVOKE     ShowWindow, eax, SW_HIDE
                  INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, FALSE, -1  ; N O T E
                     mov     [ebx].LIST.hEdit, 0
               .endif
            .endif
               and     ReturnOn, 0
         .else
               mov     eax, [ebx].LIST.hEdit
            .if eax
;               INVOKE     ShowWindow, eax, SW_HIDE
;                  mov     [ebx].LIST.hEdit, 0
            .endif
         .endif
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_CLEAREDIT
           call     GetMem
            mov     eax, [ebx].LIST.hEdit
         .if eax
              push     fCancelEdit
               mov     fCancelEdit, TRUE
            INVOKE     ShowWindow, eax, SW_HIDE
               pop     fCancelEdit
               mov     [ebx].LIST.hEdit, 0
         .endif
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_GETCOLTYPE
           call     GetMem
            mov     eax, wParam
         .if eax < [ebx].LIST.Cols
               mov     ecx, sizeof COLUMN
               mul     ecx
               lea     edi, [ebx+eax+sizeof LIST]
               mov     eax, [edi].COLUMN.ColumnType
         .else
            xor     eax, eax
         .endif
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_GETCOLWIDTH
           call     GetMem
            mov     eax, wParam
         .if eax < [ebx].LIST.Cols
               mov     ecx, sizeof COLUMN
               mul     ecx
               lea     edi, [ebx+eax+sizeof LIST]
               mov     eax, [edi].COLUMN.ColWth
         .else
            xor     eax, eax
         .endif
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_SETCOLWIDTH
           call     GetMem
            mov     ecx, wParam
         .if ecx < [ebx].LIST.Cols
               mov     eax, sizeof COLUMN
               mul     ecx
               lea     edi, [ebx+eax+sizeof LIST]
               mov     eax, lParam
               mov     [edi].COLUMN.ColWth, eax
               mov     edx, [edi].COLUMN.Colxp
            .while ecx < [ebx].LIST.Cols
                  mov     [edi].COLUMN.Colxp, edx
                  add     edx, [edi].COLUMN.ColWth
                  add     edi, sizeof COLUMN
                  inc     ecx
            .endw
               mov     [ebx].LIST.SumColWths, edx
            INVOKE     SendMessage, hwnd, WM_SIZE, 0, 0
            INVOKE     InvalidateRect, [ebx].LIST.hHeader, NULL, TRUE
            INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE
         .endif
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_GETHDRHEIGHT
           call     GetMem
            mov     eax, [ebx].LIST.HeaderHgt
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_SETHDRHEIGHT
           call     GetMem
            mov     eax, lParam
            mov     [ebx].LIST.HeaderHgt, eax
         INVOKE     SendMessage, hwnd, WM_SIZE, 0, 0
         INVOKE     InvalidateRect, [ebx].LIST.hHeader, NULL, TRUE
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_GETROWHEIGHT
           call     GetMem
            mov     eax, [ebx].LIST.RowHgt
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_SETROWHEIGHT
           call     GetMem
            mov     eax, lParam
         .if eax
               mov     [ebx].LIST.RowHgt, eax
            INVOKE     SendMessage, [ebx].LIST.hList, LB_SETITEMHEIGHT, 0, eax
            INVOKE     SendMessage, hwnd, WM_SIZE, 0, 0
            INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE
         .endif
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_RESETCONTENT
           call     GetMem
         INVOKE     ShowHide, [ebx].LIST.hList, FALSE
            mov     eax, [ebx].LIST.hMem
         .if eax
            INVOKE     GlobalFree, eax
               mov     eax, [ebx].LIST.hString
            .if eax
               INVOKE     GlobalFree, eax
            .endif
            INVOKE     SendMessage, [ebx].LIST.hList, LB_RESETCONTENT, 0, 0
               xor     eax, eax
               mov     [ebx].LIST.hMem, eax
               mov     [ebx].LIST.rpMemFree, eax
               mov     [ebx].LIST.MemSize, eax
               mov     [ebx].LIST.Col, eax
               mov     [ebx].LIST.Row, eax
               mov     [ebx].LIST.Rows, eax
               mov     [ebx].LIST.ActRows, eax
               mov     [ebx].LIST.hString, eax
               mov     [ebx].LIST.rpStrFree, eax
               mov     [ebx].LIST.StrMemSize, eax
;               mov     [ebx].LIST.VScrollPos, eax
               mov     [ebx].LIST.SortFlag, 0
               and     HitSelOn, 0
         .endif
         INVOKE     SendMessage, hwnd, WM_SIZE, 0, 0
         INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_COLUMNSORT
           call     GetMem

            mov     esi, LeftRight
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSELITEMS, 512, SelArray[esi]
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSELCOUNT, 0, 0
            mov     SelSortCnt, eax
            mov     ecx, eax
            xor     edi, edi
            mov     esi, LeftRight
            mov     esi, SelArray[esi]
         .while (ecx)
               mov     eax, [esi+edi*4]
              push     ecx
            INVOKE     SendMessage, [ebx].LIST.hList, LB_GETITEMDATA, eax, 0
               mov     SelSort[edi*4], eax
               pop     ecx
               inc     edi
               dec     ecx
         .endw
         INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, FALSE, -1
         INVOKE     ShowHide, [ebx].LIST.hList, FALSE
         .if [ebx].LIST.Rows > 1
               mov     eax, wParam
            .if eax < [ebx].LIST.Cols
               INVOKE     ListSortColumn, ebx, wParam, lParam

               INVOKE     SendMessage, [ebx].LIST.hList, LB_GETTOPINDEX, 0, 0
                 push     eax
                  mov     esi, LeftRight
                  mov     esi, SelArray[esi]
                  xor     edi, edi
               .while (SelSortCnt)
                     mov     ecx, [esi+edi*4]
                  INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, TRUE, ecx
                     inc     edi
                     dec     SelSortCnt
               .endw
;               INVOKE     SendMessage, hwnd, CM_SCROLLLIST, 0, 0
                  pop     eax
               INVOKE     SendMessage, [ebx].LIST.hList, LB_SETTOPINDEX, eax, 0
               INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE
            .endif
         .endif
           call     RelMem
            jmp     Ret0

      .elseif eax == CM_GETSORT
           call     GetMem
            mov     eax, [ebx].LIST.SortFlag
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV



      .elseif eax == CM_GETHDRTEXT
           call     GetMem
            mov     eax, [ebx].LIST.Cols
            dec     eax
            mov     ColumnCnt, eax
            mov     eax, wParam
         .if eax < ColumnCnt ;[ebx].LIST.Cols
               mov     ecx, sizeof COLUMN
               mul     ecx
               lea     edi, [ebx+eax+sizeof LIST]
               mov     eax, [edi].COLUMN.lpszhdrtext
            .if eax
               INVOKE     ListGetText, ebx, eax, lParam
            .endif
         .else
               xor     eax, eax
         .endif
           push     eax
           call     RelMem
            pop     eax
            jmp     RetV

      .elseif eax == CM_SETHDRTEXT
           call     GetMem
            mov     eax, wParam
         .if eax < [ebx].LIST.Cols
               mov     ecx, sizeof COLUMN
               mul     ecx
               lea     edi, [ebx+eax+sizeof LIST]
               mov     eax, lParam
            .if eax
               INVOKE     ListAddText, ebx, lParam
            .endif
               mov     [edi].COLUMN.lpszhdrtext, eax
            INVOKE     InvalidateRect, [ebx].LIST.hHeader, NULL, TRUE
         .endif
           call     RelMem
            jmp     Ret0
      .endif
      INVOKE     DefWindowProc, hwnd, wMsg, wParam, lParam
         ret

Ret0:
         xor     eax, eax

RetV:
         ret
      
Format:
         lea      edx, szBuff01[512-64]
      INVOKE     ListGetText, ebx, eax, edx
        push     ebx
        push     esi
        push     edi
         lea     ebx, szBuff01[512-64]
         lea     edi, szBuff01[512-66]
         mov     byte ptr [edi+1], 0
         lea     esi, szBuff01
      INVOKE     lstrlen, ebx
        push     eax
      INVOKE     lstrlen, esi
         mov     ecx, eax
         pop     edx
      .while ecx && edx
            mov     al, [esi+ecx-1]
         .if al != '-'
               dec     edx
               mov     al, [ebx+edx]
            .if al == '#'
                  dec     ecx
                  mov     al, [esi+ecx]
            .endif
         .else
               xor     ecx, ecx
         .endif
            mov     [edi], al
            dec     edi
      .endw
         inc     edi
      INVOKE     lstrcpy, addr szBuff01, edi
         pop     edi
         pop     esi
         pop     ebx
        retn
      
SetNotify:
         mov     eax, hwnd
      .if DropOn
;DSPValue hWnd, eax, 1, 'm'
            mov     eax, DropFrom
      .endif
         mov     ln.nmhdr.hwndFrom, eax
         mov     eax, [ebx].LIST.ID
         mov     ln.nmhdr.idFrom, eax
         mov     eax, [ebx].LIST.hEdit
         mov     ln.hwnd, eax
         mov     eax, [ebx].LIST.hCList
         mov     ln.hList, eax
       movzx     eax, cx
         shr     ecx, 16
         mov     ln.Col, eax
         mov     ln.Row, ecx
         mov     ln.DragOn, 0
         mov     ln.HitList, 0
         mov     ln.HitRow, 0
         mov     ln.RButt, 0
         mov     ln.DBClick, 0
         mov     ln.FileTyp, 0
         mov     ln.fcancel, FALSE
        retn

DrawItemText:
         add     rect2.left, 2
         add     rect2.top, 1
         sub     rect2.right, 2
      INVOKE     lstrlen, addr szBuff01
         mov     ecx, eax
         mov     eax, [edi].COLUMN.ColumnAlign
      .if eax == ALIGN_LEFT
            mov     eax, DT_LEFT
      .elseif eax == ALIGN_CENTER
            mov     eax, DT_CENTER
      .else
            mov     eax, DT_RIGHT
      .endif
      INVOKE     DrawText, mDC, addr szBuff01, ecx, addr rect2, eax
         sub     rect2.left, 2
         sub     rect2.top, 1
         add     rect2.right, 2
        retn

DrawItemLine:
         mov     eax, curcol
         inc     eax
         sub     eax, [ebx].LIST.Cols
        test     [ebx].LIST.style, STYLE_GRIDFRAME
      .if ZERO?
            dec     eax
      .endif
        test     [ebx].LIST.style, STYLE_VGRIDLINES
      .if !ZERO? || !eax
         INVOKE     MoveToEx, mDC, rect2.right, rect2.top, NULL
         INVOKE     LineTo, mDC, rect2.right, rect2.bottom
      .endif
        retn

SetScroll:
      INVOKE     GetClientRect, hwnd, addr rect
      .if rect.right && rect.bottom
            mov     ecx, [ebx].LIST.HeaderHgt
            sub     rect.bottom, ecx
            jnb     @f
            mov     rect.bottom, 0
@@:
            mov     sci.cbSize, sizeof sci
            mov     sci.fMask, SIF_ALL
            mov     eax, rect.bottom
            cdq
            mov     ecx, [ebx].LIST.RowHgt
            div     ecx
            mov     sci.nPage, eax
            mov     sci.nMin, 0
            mov     eax, [ebx].LIST.Rows
         .if eax
               dec     eax
         .endif
            mov     sci.nMax, eax
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETTOPINDEX, 0, 0
            mov     sci.nPos, eax
         INVOKE     SetScrollInfo, hwnd, SB_VERT, addr sci, TRUE
            mov     eax, rect.right
            mov     sci.nPage, eax
            mov     eax, [ebx].LIST.SumColWths
            mov     sci.nMax, eax
            mov     eax, [ebx].LIST.HScrollPos
            mov     sci.nPos, eax
         INVOKE     SetScrollInfo, hwnd, SB_HORZ, addr sci, TRUE
      .endif
        retn

GetMem:
      INVOKE     GetWindowLong, hwnd, 0
      INVOKE     GlobalLock, eax
         mov     ebx, eax
        retn

RelMem:
      INVOKE     GetWindowLong, hwnd, 0
      INVOKE     GlobalUnlock, eax
        retn

WndProc ENDP

;--------------------------------------------------------------------------------
ListHdrProc PROC uses ebx esi edi hwnd:DWORD, wMsg, wParam, lParam
LOCAL    rect:RECT
LOCAL    ln:LISTNOTIFY
LOCAL    hDC:DWORD

         mov      eax, wMsg
      .if eax == WM_MOUSEMOVE
           call     GetMem
         .if fSize < 2
               mov     eax, wParam
               and     eax, MK_LBUTTON or MK_RBUTTON
            .if !eax
                  mov     fSize, 0
                  mov     ecx, [ebx].LIST.Cols
                  mov     esi, ecx
                  dec     esi
               .while ecx
                     dec     ecx
                     mov     eax, sizeof COLUMN
                     mul     ecx
                     lea     edi, [ebx+eax+sizeof LIST]
                     mov     eax, [edi].COLUMN.Colxp
                     mov     nSizeMin, eax
                     add     eax, [edi].COLUMN.ColWth
                     mov     rect.left, eax
                     mov     eax, lParam
                   movzx     eax, ax
                     mov     edx, eax
                     sub     edx, rect.left
                     mov     nSizeOfs, edx
                     mov     edx, eax
                     sub     eax, 1
                     add     edx, 2
                  .if eax <= rect.left && edx >= rect.left && ecx != esi
                        mov     nSizeCol, ecx
                     INVOKE     SetCursor, [ebx].LIST.hCursor
                        mov     fSize, 1
                     .break
                  .endif
               .endw
            .endif

         .else
            INVOKE     GetParent, hwnd
               mov     edx, eax
            INVOKE     GetClientRect, edx, addr rect
               mov     eax, lParam
             movzx     eax, ax
              cwde
               sub     eax, nSizeOfs
            .if sdword ptr eax < nSizeMin
                  mov     eax, nSizeMin
            .endif
               sub     eax, [ebx].LIST.HScrollPos
            INVOKE     MoveWindow, [ebx].LIST.hSizeBar, eax, 0, 1, rect.bottom, TRUE
            INVOKE     ShowWindow, [ebx].LIST.hSizeBar, SW_SHOW

               mov     rect.left, 0
               mov     rect.top, 0
            INVOKE     GetDC, [ebx].LIST.hSizeBar
               mov     hDC, eax
            INVOKE     CreateSolidBrush, 0000ff00h
              push     eax
            INVOKE     FillRect, hDC, addr rect, eax ;[ebx].LIST.hbrFocus
               pop     eax
            INVOKE     DeleteObject, eax
            INVOKE     ReleaseDC, [ebx].LIST.hSizeBar, hDC
            INVOKE     UpdateWindow, [ebx].LIST.hSizeBar

         .endif
           call     RelMem
            xor     eax, eax
            jmp     Ex

      .elseif eax == WM_LBUTTONDOWN
           call     GetMem
         .if fSize == 1
            INVOKE     ShowHide, [ebx].LIST.hList, FALSE
               mov     fSize, 2
            INVOKE     SetCursor, [ebx].LIST.hCursor
            INVOKE     SendMessage, hwnd, WM_MOUSEMOVE, wParam, lParam

         .else
               lea     edi, [ebx+sizeof LIST]
               mov     eax, lParam
             movzx     eax, ax
               xor     ecx, ecx
            .while ecx < [ebx].LIST.Cols
                  mov     edx, [edi].COLUMN.Colxp
                  add     edx, [edi].COLUMN.ColWth
               .if eax < edx
                      or     [edi].COLUMN.SortFlag, 1
                  INVOKE     InvalidateRect, [ebx].LIST.hHeader, NULL, TRUE
                  INVOKE     UpdateWindow, [ebx].LIST.hHeader
                  .break
               .endif
                  inc     ecx
                  add     edi, sizeof COLUMN
            .endw
         .endif
         INVOKE     SetCapture, hwnd
           call     RelMem
            xor     eax, eax
            jmp     Ex

      .elseif eax == WM_LBUTTONUP
           call     GetMem
         .if fSize
               mov     fSize, 0
               mov     eax, sizeof COLUMN
               mov     ecx, nSizeCol
               mul     ecx
               lea     edi, [ebx+eax+sizeof LIST]
               mov     eax, lParam
             movzx     eax, ax
              cwde
               sub     eax, nSizeOfs
            .if sdword ptr eax < nSizeMin
                  mov     eax, nSizeMin
            .endif
               sub     eax, nSizeMin
               mov     [edi].COLUMN.ColWth, eax
               mov     eax, [edi].COLUMN.Colxp
            .while ecx < [ebx].LIST.Cols
                  mov     [edi].COLUMN.Colxp, eax
                  add     eax, [edi].COLUMN.ColWth
                  mov     [ebx].LIST.SumColWths, eax
                  add     edi, sizeof COLUMN
                  inc     ecx
            .endw
            INVOKE     ShowWindow, [ebx].LIST.hSizeBar, SW_HIDE
            INVOKE     SendMessage, [ebx].LIST.hCList, WM_SIZE, 0, 0
            INVOKE     InvalidateRect, [ebx].LIST.hHeader, NULL, TRUE
            INVOKE     UpdateWindow, [ebx].LIST.hHeader
            INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE
            INVOKE     UpdateWindow, [ebx].LIST.hList

;---------- [Equal left and right column headers
               mov     esi, hWndListLP
               mov     edi, hWndListRP
            INVOKE     GetParent, hwnd
            .if eax != hWndListLP
                  mov     esi, hWndListRP
                  mov     edi, hWndListLP
            .endif
            INVOKE     SendMessage, esi, CM_GETCOLWIDTH, nSizeCol, 0
            INVOKE     SendMessage, edi, CM_SETCOLWIDTH, nSizeCol, eax

         .else

               lea     edi, [ebx+sizeof LIST]
               xor     ecx, ecx
            .while ecx < [ebx].LIST.Cols
                  mov     [edi].COLUMN.SortAD, 0
                  add     edi, sizeof COLUMN
                  inc     ecx
            .endw

               lea     edi, [ebx+sizeof LIST]
               xor     ecx, ecx
            .while ecx < [ebx].LIST.Cols
                 test     [edi].COLUMN.SortFlag, 1
               .if !ZERO?
                     and     [edi].COLUMN.SortFlag, -1 xor 1

                     mov     [edi].COLUMN.SortAD, 8
                  .if [edi].COLUMN.SortFlag
                        mov     [edi].COLUMN.SortAD, 9
                  .endif

                     mov     eax, [ebx].LIST.hCList
                     mov     ln.nmhdr.hwndFrom, eax
                     mov     eax, [ebx].LIST.ID
                     mov     ln.nmhdr.idFrom, eax
                     mov     ln.nmhdr.code, CN_HEADERCLICK
                     mov     ln.Col, ecx
                     mov     ln.Row, -1
                     mov     eax, hwnd
                     mov     ln.hwnd, eax
                     mov     ln.lpdata, 0
                     mov     ln.fcancel, 0
                  INVOKE     InvalidateRect, [ebx].LIST.hHeader, NULL, TRUE
                  INVOKE     UpdateWindow, [ebx].LIST.hHeader
                  INVOKE     SendMessage, [ebx].LIST.hParent, WM_NOTIFY, [ebx].LIST.ID, addr ln
                  .break
               .endif
                  inc     ecx
                  add     edi, sizeof COLUMN
            .endw
         .endif
           call     RelMem
         INVOKE     ReleaseCapture
            xor     eax, eax
            jmp     Ex

      .elseif eax == WM_LBUTTONDBLCLK
         INVOKE     ReleaseCapture
            xor     eax, eax
            jmp     Ex
      .endif
      INVOKE     GetWindowLong, hwnd, GWL_USERDATA
      INVOKE     CallWindowProc, eax, hwnd, wMsg, wParam, lParam
Ex:
         ret

GetMem:
      INVOKE     GetParent, hwnd
      INVOKE     GetWindowLong, eax, 0
      INVOKE     GlobalLock, eax
         mov     ebx, eax
        retn

RelMem:
      INVOKE     GetParent, hwnd
      INVOKE     GetWindowLong, eax, 0
      INVOKE     GlobalUnlock, eax
        retn

ListHdrProc ENDP

CustListProc PROC uses ebx esi edi, hwnd:DWORD, wMsg, wParam, lParam
LOCAL    rect:RECT
LOCAL    pt:POINT
;LOCAL    dis:DRAWITEMSTRUCT
LOCAL    hDC:DWORD, mDC, Val, SelCnt
LOCAL    szBuff01[512]:BYTE

         mov     eax, wMsg
      .if eax == WM_DRAWITEM && eax == 9999
;         assume     esi:ptr DRAWITEMSTRUCT
;           call     GetMem
;            mov     esi, lParam

               mov     esi, lParam
               lea     edi, dis
               mov     ecx, sizeof dis
               rep     movsb
         INVOKE     SetBkMode, dis.hdc, TRANSPARENT
         INVOKE     GetWindowLong, dis.hwndItem, GWL_ID
          movzx     eax, ax
            mov     ecx, sizeof COLUMN
            mul     ecx
            lea     edi, [ebx+eax+sizeof LIST]
           test     dis.itemState, ODS_SELECTED
         .if ZERO?
            INVOKE     SetTextColor, dis.hdc, [ebx].LIST.ListText
            INVOKE     FillRect, dis.hdc, addr dis.rcItem, [ebx].LIST.hbrback
         .else
            INVOKE     GetSysColor, COLOR_HIGHLIGHTTEXT
            INVOKE     SetTextColor, dis.hdc, eax
            INVOKE     FillRect, dis.hdc, addr dis.rcItem, [ebx].LIST.hbrSelect ;COLOR_HIGHLIGHT+1
            .if [edi].COLUMN.hImageList
               INVOKE     CopyRect, addr rect, addr dis.rcItem
                  mov     rect.right, 18
               INVOKE     FillRect, dis.hdc, addr rect, [ebx].LIST.hbrback
            .endif
         .endif
         .if [edi].COLUMN.hImageList
            INVOKE     CopyRect, addr rect, addr dis.rcItem
               add     dis.rcItem.left, 18
               inc     rect.left
               mov     eax, rect.left
               add     eax, 16
               mov     rect.right, eax
            INVOKE     CreateRectRgn, rect.left, rect.top, rect.right, rect.bottom
              push     eax
            INVOKE     SelectClipRgn, dis.hdc, eax
               pop     eax
            INVOKE     DeleteObject, eax
            INVOKE     ImageList_Draw, [edi].COLUMN.hImageList, dis.itemData,\
                       dis.hdc, rect.left, rect.top, ILD_NORMAL
            INVOKE     SelectClipRgn, dis.hdc, NULL
         .endif
         INVOKE     SendMessage, dis.hwndItem, LB_GETTEXT, dis.itemID, addr szBuff01
         INVOKE     lstrlen, addr szBuff01
            mov     ecx, dis.rcItem.left
            add     ecx, 2
            mov     edx, dis.rcItem.top
            inc     edx
         INVOKE     TextOut, dis.hdc, ecx, edx, addr szBuff01, eax
           call     RelMem
;         assume     esi:nothing

      .elseif eax == WM_PAINT
           call     GetMem
         INVOKE     GetClientRect, [ebx].LIST.hCList, addr rect
         INVOKE     SendMessage, hwnd, LB_GETTOPINDEX, 0, 0
            mov     ecx, [ebx].LIST.HeaderHgt
            sub     rect.bottom, ecx
            mov     ecx, [ebx].LIST.RowHgt
            sub     eax, [ebx].LIST.Rows
            neg     eax
            mul     ecx
            mov     edx, eax
            mov     eax, [ebx].LIST.HScrollPos
            add     rect.right, eax
            mov     eax, [ebx].LIST.SumColWths
            inc     eax
         .if eax < rect.right || edx < rect.bottom
              push    edx
              push    eax
            INVOKE     GetDC, hwnd
               mov     hDC, eax
               pop     eax
            .if eax < rect.right
                  mov     rect.left, eax
               INVOKE     FillRect, hDC, addr rect, [ebx].LIST.hbrback
                  mov     eax, rect.left
                  mov     rect.right, eax
            .endif
               pop     edx
            .if edx < rect.bottom
                  mov     rect.top, edx
                  mov     rect.left, 0
               INVOKE     FillRect, hDC, addr rect, [ebx].LIST.hbrback
            .endif
            INVOKE     ReleaseDC, hwnd, hDC
         .endif
           call     RelMem

      .elseif eax == WM_ERASEBKGND
            xor     eax, eax
            ret

      .elseif eax == WM_KEYDOWN
            mov     edx, wParam
            mov     eax, lParam
            shr     eax, 16
            and     eax, 3ffh
;DSPValue hWnd, edx, 1, 't'
;DSPValue hWndStat, eax, 1, 's'
;---------- [Enter
         .if edx == 0dh && (eax == 11ch || eax == 1ch)
              call     GetMem
            INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSELCOUNT, 0, 0
            .if eax == 1
               INVOKE     SendMessage, [ebx].LIST.hList, LB_GETITEMDATA, [ebx].LIST.Row, 0
                  mov     edx, eax
                  mov     ecx, [ebx].LIST.Cols
                  dec     ecx
               INVOKE     ListGetCellData, ebx, edx, ecx, addr Val
                  mov     eax, Val
                  and     eax, 0ffffh
                  mov     FileTyp, eax
                  mov     DBClickOn, 1
               INVOKE     SendMessage, [ebx].LIST.hCList, CM_DBCLICK, 0, [ebx].LIST.Row
                  and     DBClickOn, 0
            .endif
               jmp     Ex

;---------- [Down
         .elseif edx == 28h && (eax == 150h || eax == 50h)
              call     GetMem
               mov     eax, [ebx].LIST.Row
               inc     eax
               mov     ecx, [ebx].LIST.ActRows
               dec     ecx
            .if eax > ecx
                  jmp     Ex
                  mov     eax, ecx
            .endif
            INVOKE     SendMessage, [ebx].LIST.hList, LB_GETITEMDATA, eax, 0
               mov     edx, eax
               mov     ecx, [ebx].LIST.Cols
               dec     ecx
            INVOKE     ListGetCellData, ebx, edx, ecx, addr Val
            .if Val == 0
                  jmp     Ex
            .endif
            INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, FALSE, -1
               mov     eax, [ebx].LIST.Row
               inc     eax
            INVOKE     SendMessage, [ebx].LIST.hCList, CM_SETCURSEL, [ebx].LIST.Col, eax
               jmp     Ex

;---------- [Up
         .elseif edx == 26h && (eax == 148h || eax == 48h)
              call     GetMem
            INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, FALSE, -1
               mov     eax, [ebx].LIST.Row
            .if eax
                  dec     eax
            .endif
            INVOKE     SendMessage, [ebx].LIST.hCList, CM_SETCURSEL, [ebx].LIST.Col, eax
               jmp     Ex

;---------- [PgUp
         .elseif edx == 21h && (eax == 149h || eax == 49h)
              call     GetMem
            INVOKE     SendMessage, [ebx].LIST.hCList, WM_VSCROLL, SB_PAGEUP, 0
               jmp     Ex

;---------- [PgDn
         .elseif edx == 22h && (eax == 151h || eax == 51h)
              call     GetMem
            INVOKE     SendMessage, [ebx].LIST.hCList, WM_VSCROLL, SB_PAGEDOWN, 0
               jmp     Ex
         .endif

      .elseif eax == WM_CHAR && eax == 9999
           call     GetMem
         .if wParam == VK_TAB
            INVOKE     GetAsyncKeyState, VK_SHIFT
            INVOKE     SendMessage, [ebx].LIST.hParent, WM_NEXTDLGCTL, eax, 0
         .else
            INVOKE     ShowHide, hwnd, TRUE
               mov     edx, wParam
            .if edx != VK_RETURN && eax
               INVOKE     SendMessage, eax, WM_CHAR, wParam, lParam
            .endif
         .endif
            jmp     Ex

      .elseif eax == WM_LBUTTONDOWN
           call     GetMem
;         INVOKE     SetCapture, hwnd
         INVOKE     SetFocus, hwnd
            and     DragFrTree, 0
            mov     DragOn, 1
         INVOKE     SendMessage, [ebx].LIST.hCList, CM_SENDDRAG, 0, 0
;         INVOKE     SendMessage, [ebx].LIST.hCList, CM_SETACTIVE, WM_LBUTTONDOWN, 1

            and     xPos, 0
            and     yPos, 0
            mov     eax, [ebx].LIST.hCList
            mov     DropFrom, eax

         INVOKE     SendMessage, hwnd, LB_GETTOPINDEX, 0, 0
           push     eax
            mov     eax, lParam
            shr     eax, 16
            cdq
            mov     ecx, [ebx].LIST.RowHgt
            div     ecx
            pop     ecx
            add     eax, ecx
            mov     RowNum, eax
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETITEMDATA, eax, 0
            mov     edx, eax
            mov     ecx, [ebx].LIST.Cols
            dec     ecx
           push     edx
           push     ecx
         INVOKE     ListGetCellData, ebx, edx, ecx, addr Val
            pop     ecx
            pop     edx
         .if Val == 9
               mov     Val, 2
            INVOKE     ListSetCellData, ebx, edx, ecx, addr Val
               and     HitSelOn, 0
         .endif
            mov     eax, Val
            and     eax, 0ffffh
            mov     FrType, eax
         .if FrType == 1
               mov     FrType, 0
         .endif
         .if !eax
               jmp     Ex
         .endif
            mov     esi, LeftRight
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSELITEMS, 512, SelArray[esi]
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSELCOUNT, 0, 0
            mov     SelCnt, eax
            mov     ecx, eax
            mov     esi, LeftRight
            mov     esi, SelArray[esi]
            xor     edx, edx
         .while (ecx)
               mov     eax, [esi+edx*4]
            .if eax == RowNum
               .break
            .endif
               inc     edx
               dec     ecx
         .endw

           push     ecx
         INVOKE     GetAsyncKeyState, VK_SHIFT
           push     eax
         INVOKE     GetAsyncKeyState, VK_CONTROL
            pop     ecx
            and     eax, 0ffffh
            and     ecx, 0ffffh
            and     ShiftOn, 0
            and     CtrlOn, 0
         .if eax == 8001h
               inc     CtrlOn
         .endif
         .if ecx == 8001h
               inc     ShiftOn
         .endif
            pop     ecx
         .if !CtrlOn && !ShiftOn && SelCnt < 2 || !CtrlOn && !ShiftOn && !ecx
            INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, FALSE, -1
         .endif

            and     MultSelOn, 0
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSEL, RowNum, 0
         .if eax && CtrlOn
            INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, FALSE, RowNum
               mov     MultSelOn, 1
            .if CtrlOn
                  and     HitSelOn, 0
            .endif
         .else
            INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, TRUE, RowNum
.if !HitSelOn
               mov     HitSelOn, 1
.endif
         .endif
            mov     eax, RowNum
         .if eax != [ebx].LIST.Row
               mov     HitSelOn, 1
         .endif
         INVOKE     SendMessage, [ebx].LIST.hCList, CM_SETACTIVE, WM_LBUTTONDOWN, 1
           call     RelMem
            jmp     ExZ

      .elseif eax == WM_LBUTTONUP
         INVOKE     ReleaseCapture  ; Remove
         INVOKE     LoadCursor, 0, IDC_ARROW
         INVOKE     SetCursor, eax
            and     DragOn, 0
;            and     FrType, 0
            and     DragFrTree, 0
           call     GetMem
         INVOKE     SendMessage, [ebx].LIST.hCList, CM_SENDDRAG, 0, 0
;DSPValue hWnd, DropOn, 1, 't'

.if DropOn
   INVOKE     SendMessage, [ebx].LIST.hCList, CM_SENDDROP, 0, 0
     call     RelMem
      jmp     Ex
.endif

         INVOKE     SetFocus, hwnd
         INVOKE     SendMessage, hwnd, LB_GETCOUNT, 0, 0
         INVOKE     SendMessage, hwnd, LB_GETTOPINDEX, 0, 0
           push     eax
            mov     eax, lParam
            shr     eax, 16
            cdq
            mov     ecx, [ebx].LIST.RowHgt
            div     ecx
            pop     ecx
            add     eax, ecx
         INVOKE     SendMessage, [ebx].LIST.hList, LB_GETITEMDATA, eax, 0
            mov     edx, eax
            mov     ecx, [ebx].LIST.Cols
            dec     ecx
         INVOKE     ListGetCellData, ebx, edx, ecx, addr Val
            mov     eax, Val
            and     eax, 0ffffh
            mov     FileTyp, eax
         .if !eax
               jmp     Ex
         .endif

         .if DBClickOn
;DSPValue hWnd, [ebx].LIST.Row, 1, 'm'
            INVOKE     SendMessage, [ebx].LIST.hCList, CM_DBCLICK, 0, [ebx].LIST.Row  ; ecx = col - eax = Row
               and     DBClickOn, 0
               jmp     Ex
         .endif

;         .if !al
;            INVOKE     SendMessage, [ebx].LIST.hCList, CM_SETACTIVE, 1, TRUE
;               jmp     Ex
;         .endif

.if !FrType
      jmp     Ex
.endif

         INVOKE     GetAsyncKeyState, VK_SHIFT
           push     eax
         INVOKE     GetAsyncKeyState, VK_CONTROL
            pop     ecx
            and     eax, 0ffffh
            and     ecx, 0ffffh
            and     ShiftOn, 0
            and     CtrlOn, 0
         .if eax == 8001h
               inc     CtrlOn
         .endif
         .if ecx == 8001h
               inc     ShiftOn
         .endif
            and     SelCnt, 0
         .if eax != 8001h && ecx != 8001h
            INVOKE     SendMessage, [ebx].LIST.hList, LB_GETSELCOUNT, 0, 0
               mov     SelCnt, eax
.if eax > 1
            INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, FALSE, -1   ;;;;
.endif
         .endif


            lea     edi, [ebx+sizeof LIST]
            mov     eax, lParam
          movzx     eax, ax
            xor     ecx, ecx
            xor     edx, edx
         .while ecx < [ebx].LIST.Cols
               add     edx, [edi].COLUMN.ColWth
            .if sdword ptr eax >= [edi].COLUMN.Colxp && sdword ptr eax <= edx
                  xor     eax, eax
               .break
            .endif
               add     edi, sizeof COLUMN
               inc     ecx
         .endw
         .if ecx < [ebx].LIST.Cols
              push     eax
              push     ecx
            INVOKE     SendMessage, hwnd, LB_GETCOUNT, 0, 0
              push     eax
            INVOKE     SendMessage, hwnd, LB_GETTOPINDEX, 0, 0
              push     eax
               mov     eax, lParam
               shr     eax, 16
               cdq
               mov     ecx, [ebx].LIST.RowHgt
               div     ecx
               pop     ecx
               add     eax, ecx
mov     [ebx].LIST.Row, eax
               pop     edx
               pop     ecx
            .if eax < edx
;               .if eax != RowNum ;[ebx].LIST.Row
               .if eax == RowNum ;[ebx].LIST.Row
                     pop     edx
                     xor     edx, edx
                    push     edx
               .endif
               .if ([ebx].LIST.style & STYLE_NOFOCUS)
                     xor     [ebx].LIST.style, STYLE_NOFOCUS
               .endif

               .if HitSelOn && eax == RowNum && wParam != 2
               .else
                     mov     HitSelOn, 0
               .endif
.if eax != RowNum && SelCnt < 2
      mov     eax, RowNum
      mov     [ebx].LIST.Row, eax
.endif

               .if eax == RowNum
                  .if !MultSelOn
                        mov     ecx, 0
                     INVOKE     SendMessage, [ebx].LIST.hCList, CM_SETCURSEL, ecx, RowNum  ; ecx = col - eax = Row
                  .endif
                     and     MultSelOn, 0

                     pop     eax
                     mov     ecx, Val
                  .if HitSelOn > 1 && cl != 1 && !CtrlOn
                     INVOKE     ShowHide, hwnd, TRUE
                        and     HitSelOn, 0
                  .endif

               .elseif SelCnt
                     mov     esi, LeftRight
                     mov     esi, SelArray[esi]
                     xor     ecx, ecx
                  .while (SelCnt)
                        mov     edi, [esi+ecx*4]
                       push     ecx
                     INVOKE     SendMessage, [ebx].LIST.hList, LB_SETSEL, TRUE, edi
                        pop     ecx
                        inc     ecx
                        dec     SelCnt
                  .endw
               .endif
                  inc     HitSelOn
            .else
                  pop     eax
            .endif
         .endif
           call     RelMem
            jmp     Ex

      .elseif eax == WM_RBUTTONDOWN
           call     GetMem
;            and     RButtonOn, 0
         INVOKE     GetCursorPos, addr pt
         INVOKE     ScreenToClient, [ebx].LIST.hList, addr pt
            mov     eax, pt.y
            shl     eax, 16
           push     eax
         INVOKE     SendMessage, [ebx].LIST.hList, WM_LBUTTONDOWN, MK_RBUTTON, eax
            pop     eax
;         INVOKE     SendMessage, [ebx].LIST.hList, WM_LBUTTONUP, MK_RBUTTON, eax
           call     RelMem
            jmp     ExZ

      .elseif eax == WM_RBUTTONUP
           call     GetMem
            and     RButtonOn, 0
         INVOKE     GetCursorPos, addr pt
         INVOKE     ScreenToClient, [ebx].LIST.hList, addr pt
            mov     eax, pt.y
            shl     eax, 16
            mov     lParam, eax
         INVOKE     SendMessage, hwnd, LB_GETCOUNT, 0, 0
         INVOKE     SendMessage, hwnd, LB_GETTOPINDEX, 0, 0
           push     eax
            mov     eax, lParam
            shr     eax, 16
            cdq
            mov     ecx, [ebx].LIST.RowHgt
            div     ecx
            pop     ecx
            add     eax, ecx
         .if eax == RowNum ;[ebx].LIST.Row
               mov     RButtonOn, 1
;            INVOKE     SendMessage, [ebx].LIST.hList, WM_LBUTTONDOWN, MK_RBUTTON, lParam
            INVOKE     SendMessage, [ebx].LIST.hList, WM_LBUTTONUP, MK_RBUTTON, lParam
               mov     HitSelOn, 0 ;2
               and     RButtonOn, 0
         .endif
           call     RelMem
            jmp     ExZ

      .elseif eax == WM_MOUSEMOVE
            mov     RowSelOn, 1
            and     DropOn, 0
           call     GetMem
         .if wParam == MK_LBUTTON
;INVOKE     SetCapture, hWnd  ; Remove
               mov     ecx, lParam
               mov     edx, ecx
               shr     edx, 16
               and     ecx, 0ffffh
            .if edx == 0
               INVOKE     SendMessage, hwnd, WM_VSCROLL, SB_LINEUP, 0
            .endif
            INVOKE     GetCursorPos, addr pt
;INVOKE     ScreenToClient, [ebx].LIST.hList, addr pt
            INVOKE     ScreenToClient, hWnd, addr pt
            .if !xPos
                  mov     eax, pt.x
                  mov     xPos, eax
                  mov     eax, pt.y
                  mov     yPos, eax
            .endif

   mov     ecx, LeftWth
   mov     edx, TreeWth

.if pt.x <= ecx
      sub     edx, 10
;DSPValue hWnd, pt.x, 1, 't'
;DSPValue hWndStat, edx, 1, 's'
   .if TreeOn && pt.x <= edx
      INVOKE     GetCapture
      .if eax != hWnd
         INVOKE     ReleaseCapture
         INVOKE     SetCapture, hWnd
;DSPValue hWnd, 1111, 1, 't'
;               INVOKE     SetCursor, [ebx].LIST.hDrop
;                  mov     DropOn, 1
INVOKE     SetFocus, hWnd
  call     RelMem
   jmp     ExZ
      .endif
;INVOKE     SetFocus, hWnd
;  call     RelMem
;   jmp     ExZ
   .else
      INVOKE     GetCapture
      .if eax != hWndListL
         INVOKE     ReleaseCapture
         INVOKE     SetCapture, hWndListL
;DSPValue hWnd, 2222, 1, 't'
      .endif
   .endif
.elseif pt.x > ecx
   INVOKE     GetCapture
   .if eax != hWndListR
      INVOKE     ReleaseCapture
      INVOKE     SetCapture, hWndListR
;DSPValue hWnd, 3333, 1, 't'
   .endif
.endif

mov     eax, TreeWth
add     eax, 5
;DSPValue hWnd, pt.x, 1, 't'
;DSPValue hWndStat, eax, 1, 's'
.if TreeOn && pt.x <= eax
;;;DSPValue hWnd, 4444, 1, 't'
;INVOKE     SetCapture, hWnd  ; Replace
;;;INVOKE     SetFocus, hWnd
;;;  call     RelMem
;;;   jmp     ExZ
.else ;if
;INVOKE     ReleaseCapture  ; Replace
.endif

               mov     ecx, xPos
               sub     ecx, 2
               mov     edx, xPos
               add     edx, 2
            .if pt.x > ecx && pt.x < edx
                  mov     ecx, yPos
                  sub     ecx, 2
                  mov     edx, yPos
                  add     edx, 2
               .if pt.y > ecx && pt.y < edx
                  INVOKE     LoadCursor, 0, IDC_ARROW
                  INVOKE     SetCursor, eax
                    call     RelMem
                     jmp     ExZ
               .endif
            .endif
              call     GetTarget
; esi = File type
; edi = row number

;DSPValue hWnd, esi, 1, 't'
;DSPValue hWndStat, edi, 1, 's'
               mov     eax, LeftWth
            .if !LeftRight
               .if pt.x < eax && esi != 2 && !DragFrTree ||\
                   pt.x < eax && esi == 2 && !DragFrTree && edi == RowNum || !FrType
                  INVOKE     SetCursor, [ebx].LIST.hDrag
               .else
                  INVOKE     SetCursor, [ebx].LIST.hDrop
                     mov     DropOn, 1
               .endif
            .else
               .if pt.x > eax && esi != 2 && !DragFrTree ||\
                   pt.x > eax && esi == 2 && !DragFrTree && edi == RowNum || !FrType
                  INVOKE     SetCursor, [ebx].LIST.hDrag
               .else
                  INVOKE     SetCursor, [ebx].LIST.hDrop
                     mov     DropOn, 1
               .endif
            .endif

         .else
            INVOKE     LoadCursor, 0, IDC_ARROW
            INVOKE     SetCursor, eax
         .endif

            mov     eax, [ebx].LIST.hList
            mov     ecx, hWndListL
         .if eax == hWndListL && HitList == 1
               mov     DropTo, 77777
         .elseif eax == hWndListR && HitList == 0
               mov     DropTo, 77777
         .endif

         .if DropOn
;INVOKE     ReleaseCapture  ; Replace
            .if DragFrTree
                  mov     eax, hWndTree
                  mov     DropFrom, eax
            .endif

            .if esi == 2 && edi != DropTo
                  mov     DropTo, edi ;ecx
                  mov     DropClr, edi ;ecx
INVOKE     GetClientRect, [ebx].LIST.hList, addr rect
   mov     rect.right, 40
               INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE

                  mov     eax, [ebx].LIST.hList
                  mov     ecx, hWndListL
               .if eax == hWndListL
                     mov     ecx, hWndListR
               .endif
                  and     DropOn, 0
               INVOKE     InvalidateRect, ecx, NULL, TRUE
                  mov     DropOn, 1

            .elseif esi != 2 && DropClr != 88888 ;&& edi != 88888
                  mov     DropTo, 88888
                  mov     DropClr, 88888
               INVOKE     InvalidateRect, [ebx].LIST.hList, NULL, TRUE
            .endif

               mov     HitList, 1
               mov     eax, [ebx].LIST.hList
            .if eax == hWndListL
                  mov     HitList, 0
            .endif

         .elseif DropClr != 99999
               and     DropTo, 0
               mov     DropClr, 99999
;               mov     eax, [ebx].LIST.hList
;               mov     ecx, hWndListL
;            .if eax == hWndListL
;                  mov     ecx, hWndListR
;            .endif
            INVOKE     InvalidateRect, hWndListL, NULL, TRUE
            INVOKE     InvalidateRect, hWndListR, NULL, TRUE
         .endif

           call     RelMem
            jmp     ExZ

      .elseif eax == WM_LBUTTONDBLCLK
           call     GetMem
            mov     DBClickOn, 1
            and     HitSelOn, 0
         .if [ebx].LIST.Col == 0
;            INVOKE     ShowHide, hwnd, TRUE
         .endif
           call     RelMem
            jmp     ExZ

      .elseif eax == WM_SETFOCUS
           call     GetMem
            mov     eax, [ebx].LIST.hEdit
         .if eax
            INVOKE     ShowWindow, eax, SW_HIDE
               mov     [ebx].LIST.hEdit, 0
         .endif
           call     RelMem

      .elseif eax == WM_MOUSEWHEEL
         INVOKE     GetParent, hwnd
         INVOKE     SendMessage, eax, wMsg, wParam, lParam
            jmp     ExZ

      .elseif eax == WM_GETDLGCODE
            mov     eax, DLGC_CODE
            ret
      .endif
      INVOKE     GetWindowLong, hwnd, GWL_USERDATA
      INVOKE     CallWindowProc, eax, hwnd, wMsg, wParam, lParam
         ret
Ex:
        call     RelMem
ExZ:
         xor      eax, eax
         ret

GetTarget:
      INVOKE     SendMessage, hwnd, LB_GETTOPINDEX, 0, 0
        push     eax
         mov     eax, lParam
         shr     eax, 16
         cdq
         mov     ecx, [ebx].LIST.RowHgt
         div     ecx
         pop     ecx
         add     eax, ecx
        push     eax
      INVOKE     SendMessage, [ebx].LIST.hList, LB_GETITEMDATA, eax, 0
         mov     edx, eax
         mov     ecx, [ebx].LIST.Cols
         dec     ecx
      INVOKE     ListGetCellData, ebx, edx, ecx, addr Val
         mov     esi, Val
         and     esi, 0ffffh
         pop     edi
        retn

GetMem:
      INVOKE     GetParent, hwnd
      INVOKE     GetWindowLong, eax, 0
      INVOKE     GlobalLock, eax
         mov      ebx, eax
        retn

RelMem:
      INVOKE     GetParent, hwnd
      INVOKE     GetWindowLong, eax, 0
      INVOKE     GlobalUnlock, eax
        retn

CustListProc ENDP

ShowHide PROC uses edi hLst:DWORD, fShow

      INVOKE     GetParent, hLst
      .if fShow
            mov     edi, eax
         INVOKE     SendMessage, edi, CM_GETCURCOL, 0, 0
           push     eax
         INVOKE     SendMessage, edi, CM_GETCURROW, 0, 0
            pop     ecx
         INVOKE     SendMessage, edi, CM_ENTEREDIT, ecx, eax
      .else
         INVOKE     SendMessage, eax, CM_ENDEDIT, 0, TRUE
      .endif
         ret

ShowHide ENDP

EdtTextProc PROC uses ebx edi hwnd:DWORD, wMsg, wParam, lParam

         mov      eax, wMsg
      .if eax == WM_CHAR
            mov     eax, wParam
         .if eax == VK_TAB
            INVOKE     ShowWindow, hwnd, SW_HIDE
              call     GetMem
            INVOKE     SendMessage, [ebx].LIST.hList, WM_KEYDOWN, 09h, 0f0001h
            INVOKE     SendMessage, [ebx].LIST.hList, WM_LBUTTONDBLCLK, 0, 0
               mov     eax, [ebx].LIST.Col
               mov     edx, sizeof COLUMN
               mul     edx
               lea     edi, [ebx+eax+sizeof LIST]
            INVOKE     SendMessage, [edi].COLUMN.EditWnd, EM_SETSEL, -1, 0
              call     RelMem
               xor     eax, eax
               jmp     Ex

         .elseif eax == VK_RETURN
mov     ReturnOn, 1
            INVOKE     ShowWindow, hwnd, SW_HIDE
               xor     eax, eax
               jmp     Ex
         .elseif eax == VK_ESCAPE
               mov     fCancelEdit, TRUE
            INVOKE     ShowWindow, hwnd, SW_HIDE
               mov     fCancelEdit, FALSE
               xor     eax, eax
               jmp     Ex
         .endif
      .elseif eax == WM_SHOWWINDOW
         .if !wParam && !fCancelEdit
               mov     fCancelEdit, TRUE
              call     Update
               mov     fCancelEdit, FALSE
         .endif
      .elseif eax == WM_GETDLGCODE
            mov     eax, DLGC_CODE
            jmp     Ex
      .endif
      INVOKE     GetWindowLong, hwnd, GWL_USERDATA
      INVOKE     CallWindowProc, eax, hwnd, wMsg, wParam, lParam
Ex:
         ret

Update:
      INVOKE     GetWindowLong, hwnd, GWL_ID
        push     eax
      INVOKE     GetParent, hwnd
      INVOKE     GetParent, eax
         pop     ecx
      INVOKE     SendMessage, eax, CM_ENDEDIT, ecx, FALSE
        retn

GetMem:
      INVOKE     GetParent, hwnd
      INVOKE     GetParent, eax
      INVOKE     GetWindowLong, eax, 0
      INVOKE     GlobalLock, eax
         mov     ebx, eax
        retn

RelMem:
      INVOKE     GetParent, hwnd
      INVOKE     GetParent, eax
      INVOKE     GetWindowLong, eax, 0
      INVOKE     GlobalUnlock, eax
        retn

EdtTextProc ENDP

EdtLongProc PROC hwnd:DWORD, wMsg, wParam, lParam

         mov     eax, wMsg
      .if eax == WM_CHAR
            mov     eax, wParam
         .if eax == VK_RETURN
            INVOKE     ShowWindow, hwnd, SW_HIDE
               xor     eax, eax
               jmp     Ex
         .elseif eax == VK_ESCAPE
               mov     fCancelEdit, TRUE
            INVOKE     ShowWindow, hwnd, SW_HIDE
               mov     fCancelEdit, FALSE
               xor     eax, eax
               jmp     Ex
         .elseif (eax < '0' || eax > '9') && eax != '-' && eax != 8
            INVOKE     MessageBeep, MB_OK
               xor     eax, eax
               jmp     Ex
         .endif
      .elseif eax == WM_SHOWWINDOW
         .if !wParam && !fCancelEdit
               mov    fCancelEdit, TRUE
              call    Update
               mov    fCancelEdit, FALSE
         .endif
      .elseif eax == WM_GETDLGCODE
            mov     eax, DLGC_CODE
            jmp     Ex
      .endif
      INVOKE     GetWindowLong, hwnd, GWL_USERDATA
      INVOKE     CallWindowProc, eax, hwnd, wMsg, wParam, lParam
Ex:
         ret

Update:
      INVOKE     GetWindowLong, hwnd, GWL_ID
        push     eax
      INVOKE     GetParent, hwnd
      INVOKE     GetParent, eax
         pop     ecx
      INVOKE     SendMessage, eax, CM_ENDEDIT, ecx, FALSE
        retn

EdtLongProc ENDP

End DllEntry
